package gregapi.util;

import static gregapi.data.CS.*;
import gregapi.GT_API;
import gregapi.block.IBlockDebugable;
import gregapi.block.IBlockExtendedMetaData;
import gregapi.block.IBlockPlacable;
import gregapi.block.IBlockTileEntity;
import gregapi.code.*;
import gregapi.damage.DamageSources;
import gregapi.data.*;
import gregapi.data.CS.ArmorsGT;
import gregapi.data.CS.BlocksGT;
import gregapi.data.CS.ItemsGT;
import gregapi.data.CS.PotionsGT;
import gregapi.data.TC.TC_AspectStack;
import gregapi.enchants.Enchantment_Radioactivity;
import gregapi.event.BlockScanningEvent;
import gregapi.item.IItemGTContainerTool;
import gregapi.item.IItemProjectile;
import gregapi.item.IItemUpdatable;
import gregapi.item.multiitem.MultiItemRandom;
import gregapi.item.multiitem.food.IFoodStat;
import gregapi.lang.LanguageHandler;
import gregapi.network.packets.PacketSound;
import gregapi.oredict.*;
import gregapi.recipes.GT_ModHandler;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.tileentity.delegate.DelegatorTileEntity;
import gregapi.tileentity.delegate.ITileEntityDelegating;
import ic2.api.item.IC2Items;
import ic2.api.recipe.*;

import java.io.IOException;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.text.DateFormat;
import java.util.*;
import java.util.Map.Entry;

import net.minecraft.block.Block;
import net.minecraft.block.BlockFire;
import net.minecraft.block.material.Material;
import net.minecraft.client.Minecraft;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityList;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.monster.EntityBlaze;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.*;
import net.minecraft.nbt.*;
import net.minecraft.nbt.NBTBase.NBTPrimitive;
import net.minecraft.network.play.server.S07PacketRespawn;
import net.minecraft.network.play.server.S1DPacketEntityEffect;
import net.minecraft.potion.Potion;
import net.minecraft.potion.PotionEffect;
import net.minecraft.server.MinecraftServer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.util.*;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.world.chunk.Chunk;
import net.minecraftforge.common.DimensionManager;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.util.FakePlayer;
import net.minecraftforge.common.util.ForgeDirection;
import net.minecraftforge.fluids.*;
import net.minecraftforge.fluids.FluidContainerRegistry.FluidContainerData;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 * 
 * Utility for accessing the random Utility Functions in a more short manner. The Short Name is for ease of overview and stands for "UtiliTy". :P
 */
public class UT {
	public static class Fluids {
		public static int id(FluidStack aFluid) {
			if (aFluid.getFluid() == null) return -1;
			return FluidRegistry.getFluidID(aFluid.getFluid());
		}
		
		public static Fluid fluid(int aID) {
			if (aID < 0) return null;
			return FluidRegistry.getFluid(aID);
		}
		
		public static boolean equal(FluidStack aFluid1, FluidStack aFluid2) {
			return equal(aFluid1, aFluid2, F);
		}
		
		public static boolean equal(FluidStack aFluid1, FluidStack aFluid2, boolean aIgnoreNBT) {
			return aFluid1 != null && aFluid2 != null && aFluid1.getFluid() == aFluid2.getFluid() && (aIgnoreNBT || ((aFluid1.tag == null) == (aFluid2.tag == null)) && (aFluid1.tag == null || aFluid1.tag.equals(aFluid2.tag)));
		}
		
	    public static ItemStack display(Fluid aFluid) {
	    	return aFluid==null?null:display(make(aFluid, 0), F);
	    }
	    
	    public static ItemStack display(FluidStack aFluid, boolean aUseStackSize) {
	    	if (aFluid == null || aFluid.getFluid() == null) return null;
	    	ItemStack rStack = IL.Display_Fluid.getWithMeta(aUseStackSize ? aFluid.amount / 1000 : 1, id(aFluid));
	    	if (rStack == null) return null;
	    	NBTTagCompound tNBT = new NBTTagCompound();
	    	NBT.setNumber(tNBT, "a", aFluid.amount);
	    	NBT.setNumber(tNBT, "h", aFluid.getFluid().getTemperature(aFluid));
			NBT.setBoolean(tNBT, "s", aFluid.getFluid().isGaseous(aFluid));
			rStack.setTagCompound(tNBT);
	    	return rStack;
	    }
	    
		public static boolean is(FluidStack aFluid, String... aNames) {
			if (aFluid != null && aFluid.getFluid() != null) for (String aName : aNames) if (aFluid.getFluid().getName().equalsIgnoreCase(aName)) return T;
			return F;
		}
		
		public static boolean is(Fluid aFluid, String... aNames) {
			if (aFluid != null) for (String aName : aNames) if (aFluid.getName().equalsIgnoreCase(aName)) return T;
			return F;
		}
		
		/** @return if that Liquid is Water or Distilled Water */
		public static boolean water(FluidStack aFluid) {
			return aFluid != null && water(aFluid.getFluid());
		}
		
		/** @return if that Liquid is Water or Distilled Water */
		public static boolean water(Fluid aFluid) {
			return aFluid != null && (aFluid == FluidRegistry.WATER || aFluid.getName().equals("ic2distilledwater"));
		}
		
		/** @return a Liquid Stack with given amount of Water. */
		public static FluidStack water(long aAmount) {
			return make("water", aAmount);
		}
		
		/** @return if that Liquid is distilled Water */
		public static boolean distilledwater(FluidStack aFluid) {
			return aFluid != null && distilledwater(aFluid.getFluid());
		}
		
		/** @return if that Liquid is distilled Water */
		public static boolean distilledwater(Fluid aFluid) {
			return aFluid != null && aFluid.getName().equals("ic2distilledwater");
		}
		
		/** @return a Liquid Stack with given amount of distilled Water. */
		public static FluidStack distilledwater(long aAmount) {
			return make("ic2distilledwater", aAmount, "water", aAmount);
		}
		
		/** @return if that Liquid is Lava */
		public static boolean lava(FluidStack aFluid) {
			return aFluid != null && lava(aFluid.getFluid());
		}
		
		/** @return if that Liquid is Lava */
		public static boolean lava(Fluid aFluid) {
			return aFluid != null && aFluid == FluidRegistry.LAVA;
		}
		
		/** @return a Liquid Stack with given amount of Lava. */
		public static FluidStack lava(long aAmount) {
			return make("lava", aAmount);
		}
		
		/** @return if that Liquid is Steam */
		public static boolean steam(FluidStack aFluid) {
			return aFluid != null && steam(aFluid.getFluid());
		}
		
		/** @return if that Liquid is Steam */
		public static boolean steam(Fluid aFluid) {
			return aFluid != null && aFluid.getName().equals("steam");
		}
		
		/** @return a Liquid Stack with given amount of Steam. */
		public static FluidStack steam(long aAmount) {
			return make("steam", aAmount);
		}
		
		/** @return if that Liquid is Milk */
		public static boolean milk(FluidStack aFluid) {
			return aFluid != null && milk(aFluid.getFluid());
		}
		
		/** @return if that Liquid is Milk */
		public static boolean milk(Fluid aFluid) {
			return aFluid != null && aFluid.getName().equals("milk");
		}
		
		/** @return a Liquid Stack with given amount of Milk. */
		public static FluidStack milk(long aAmount) {
			return make("milk", aAmount);
		}
		
		public static boolean exists(String aFluidName) {
			return FluidRegistry.getFluid(aFluidName) != null;
		}
		
		public static FluidStack make(Fluid aFluid, long aAmount) {
			if (aFluid == null) return null;
			return new FluidStack(aFluid, Code.bindInt(aAmount));
		}
		
		public static FluidStack make(String aFluidName, long aAmount) {
			return make(FluidRegistry.getFluid(aFluidName), aAmount);
		}
		
		public static FluidStack make(String aFluidName, long aAmount, String aReplacementFluidName) {
			FluidStack rFluid = make(aFluidName, aAmount);
			return rFluid == null ? make(aReplacementFluidName, aAmount) : rFluid;
		}
		
		public static FluidStack make(String aFluidName, long aAmount, String aReplacementFluidName, long aReplacementAmount) {
			FluidStack rFluid = make(aFluidName, aAmount);
			return rFluid == null ? make(aReplacementFluidName, aReplacementAmount) : rFluid;
		}
		
		public static FluidStack make(String aFluidName, long aAmount, FluidStack aReplacementFluid) {
			FluidStack rFluid = make(aFluidName, aAmount);
			return rFluid == null ? aReplacementFluid : rFluid;
		}
		
		public static FluidStack mul(FluidStack aFluid, long aMultiplier) {
			return aFluid == null ? null : make(aFluid.getFluid(), aFluid.amount * aMultiplier);
		}
		
		public static FluidStack mul(FluidStack aFluid, long aMultiplier, long aDivider, boolean aRoundUp) {
			return aFluid == null ? null : make(aFluid.getFluid(), Code.units(aFluid.amount, aDivider, aMultiplier, aRoundUp));
		}
		
		public static String configName(FluidStack aFluid) {
			return aFluid == null || aFluid.getFluid() == null ? "" : aFluid.getFluid().getName();
		}
		
		public static String configNames(FluidStack... aFluids) {
			String rString = "";
			for (FluidStack tFluid : aFluids) rString += (tFluid == null ? "null;" : configName(tFluid) + ";");
			return rString;
		}
		
		public static String name(Fluid aFluid, boolean aLocalized) {
			if (aFluid == null) return "";
			String rName = aLocalized?aFluid.getLocalizedName(make(aFluid, 0)):aFluid.getUnlocalizedName();
			if (rName.contains("fluid.") || rName.contains("tile.")) return Code.capitalise(rName.replaceAll("fluid.", "").replaceAll("tile.", ""));
			return rName;
		}
		
		public static String name(FluidStack aFluid, boolean aLocalized) {
			if (aFluid == null) return "";
			return name(aFluid.getFluid(), aLocalized);
		}
		
		public static FluidStack[] copyArray(FluidStack... aStacks) {
			FluidStack[] rStacks = new FluidStack[aStacks.length];
			for (int i = 0; i < aStacks.length; i++) if (aStacks[i] != null) rStacks[i] = aStacks[i].copy();
			return rStacks;
		}
		
//		private static final List<FluidContainerData> sFluidContainerList = new ArrayListNoNulls<FluidContainerData>();
		private static final Map<ItemStackContainer, FluidContainerData> sFilledContainerToData = new ItemStackMap<ItemStackContainer, FluidContainerData>();
		private static final Map<ItemStackContainer, Map<String, FluidContainerData>> sEmptyContainerToFluidToData = new ItemStackMap<ItemStackContainer, Map<String, FluidContainerData>>();
		/*
		public static void reInit() {
			sFilledContainerToData.clear();
			sEmptyContainerToFluidToData.clear();
			for (FluidContainerData tData : sFluidContainerList) {
				sFilledContainerToData.put(new ItemStackContainer(tData.filledContainer), tData);
				Map<String, FluidContainerData> tFluidToContainer = sEmptyContainerToFluidToData.get(new ItemStackContainer(tData.emptyContainer));
				if (tFluidToContainer == null) {
					sEmptyContainerToFluidToData.put(new ItemStackContainer(tData.emptyContainer), tFluidToContainer = new HashMap<String, FluidContainerData>());
				}
				tFluidToContainer.put(tData.fluid.getFluid().getName(), tData);
			}
		}
		*/
		public static void addFluidContainerData(FluidContainerData aData) {
//			sFluidContainerList.add(aData);
			sFilledContainerToData.put(new ItemStackContainer(aData.filledContainer), aData);
			Map<String, FluidContainerData> tFluidToContainer = sEmptyContainerToFluidToData.get(new ItemStackContainer(aData.emptyContainer));
			if (tFluidToContainer == null) {
				sEmptyContainerToFluidToData.put(new ItemStackContainer(aData.emptyContainer), tFluidToContainer = new HashMap<String, FluidContainerData>());
			}
			tFluidToContainer.put(aData.fluid.getFluid().getName(), aData);
		}
		
	    public static ItemStack fillFluidContainer(FluidStack aFluid, ItemStack aStack, boolean aRemoveFluidDirectly, boolean aCheckIFluidContainerItems) {
	    	return fillFluidContainer(aFluid, aStack, aRemoveFluidDirectly, aCheckIFluidContainerItems, F);
	    }
	    
	    public static ItemStack fillFluidContainer(FluidStack aFluid, ItemStack aStack, boolean aRemoveFluidDirectly, boolean aCheckIFluidContainerItems, boolean aAllowPartialFilling) {
			if (Stacks.invalid(aStack) || aFluid == null) return null;
			if (aFluid.getFluid() == FluidRegistry.WATER && Stacks.equal(aStack, Stacks.make(Items.glass_bottle, 1, CS.W))) {
				if (aFluid.amount >= 250) {
					if (aRemoveFluidDirectly) aFluid.amount -= 250;
					return Stacks.make(Items.potionitem, 1, 0);
				}
				return null;
			}
	    	if (aCheckIFluidContainerItems && aStack.getItem() instanceof IFluidContainerItem && ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack) > 0 && (((IFluidContainerItem)aStack.getItem()).getFluid(aStack) == null || (Fluids.equal(((IFluidContainerItem)aStack.getItem()).getFluid(aStack), aFluid) && ((IFluidContainerItem)aStack.getItem()).getFluid(aStack).amount < ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack))) && (aAllowPartialFilling || ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack) <= aFluid.amount)) {
				if (aRemoveFluidDirectly)
		    		aFluid.amount -= ((IFluidContainerItem)aStack.getItem()).fill(aStack = Stacks.amount(1, aStack), aFluid, T);
				else
		    		((IFluidContainerItem)aStack.getItem()).fill(aStack = Stacks.amount(1, aStack), aFluid, T);
				return aStack;
	    	}
	    	Map<String, FluidContainerData> tFluidToContainer = sEmptyContainerToFluidToData.get(new ItemStackContainer(aStack));
	    	if (tFluidToContainer == null) return null;
	    	FluidContainerData tData = tFluidToContainer.get(aFluid.getFluid().getName());
	    	if (tData == null || tData.fluid.amount > aFluid.amount) return null;
	    	if (aRemoveFluidDirectly) aFluid.amount -= tData.fluid.amount;
			return Stacks.amount(1, tData.filledContainer);
	    }
	    
	    public static boolean containsFluid(ItemStack aStack, FluidStack aFluid, boolean aCheckIFluidContainerItems) {
			if (Stacks.invalid(aStack) || aFluid == null) return F;
	    	if (aCheckIFluidContainerItems && aStack.getItem() instanceof IFluidContainerItem && ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack) > 0) return aFluid.isFluidEqual(((IFluidContainerItem)aStack.getItem()).getFluid(aStack = Stacks.amount(1, aStack)));
	    	FluidContainerData tData = sFilledContainerToData.get(new ItemStackContainer(aStack));
	    	return tData!=null && tData.fluid.isFluidEqual(aFluid);
	    }
	    
		public static FluidStack getFluidForFilledItem(ItemStack aStack, boolean aCheckIFluidContainerItems) {
			if (Stacks.invalid(aStack)) return null;
			if (aCheckIFluidContainerItems && aStack.getItem() instanceof IFluidContainerItem && ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack) > 0) return ((IFluidContainerItem)aStack.getItem()).drain(Stacks.amount(1, aStack), Integer.MAX_VALUE, T);
			FluidContainerData tData = sFilledContainerToData.get(new ItemStackContainer(aStack));
			return tData==null?null:tData.fluid.copy();
		}
		
		public static ItemStack getContainerForFilledItem(ItemStack aStack, boolean aCheckIFluidContainerItems) {
			if (Stacks.invalid(aStack)) return null;
			FluidContainerData tData = sFilledContainerToData.get(new ItemStackContainer(aStack));
			if (tData != null) return Stacks.amount(1, tData.emptyContainer);
			if (aCheckIFluidContainerItems && aStack.getItem() instanceof IFluidContainerItem && ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack) > 0) {
				((IFluidContainerItem)aStack.getItem()).drain(aStack = Stacks.amount(1, aStack), Integer.MAX_VALUE, T);
				return aStack;
			}
			return null;
		}
	}
	
	public static class Books {
		public static final Map<String, ItemStack> BOOK_MAP = new HashMap<String, ItemStack>();
		public static final List<String> BOOK_LIST = new ArrayListNoNulls<String>();
		public static final List<String> MATERIAL_DICTIONARIES = new ArrayListNoNulls<String>();
		
		public static ItemStack getWrittenBook(String aMapping) {
			return getWrittenBook(aMapping, null);
		}
		
		public static ItemStack getWrittenBook(String aMapping, ItemStack aStackToPutNBT) {
			ItemStack tStack = BOOK_MAP.get(aMapping);
			if (tStack == null) return aStackToPutNBT==null?Stacks.make(Items.written_book, 1, 0):aStackToPutNBT;
			if (aStackToPutNBT == null) aStackToPutNBT = Stacks.copy(tStack);
			aStackToPutNBT.setTagCompound((NBTTagCompound)tStack.getTagCompound().copy());
			return aStackToPutNBT;
		}
		
		public static ItemStack getBookWithTitle(String aMapping) {
			return getBookWithTitle(aMapping, null);
		}
		
		public static ItemStack getBookWithTitle(String aMapping, ItemStack aStackToPutNBT) {
			ItemStack tStack = BOOK_MAP.get(aMapping);
			if (tStack == null) return aStackToPutNBT==null?Stacks.make(Items.written_book, 1, 0):aStackToPutNBT;
			if (aStackToPutNBT == null) aStackToPutNBT = Stacks.copy(tStack);
			aStackToPutNBT.setTagCompound(NBT.getNBTs(null, "title", NBT.getBookTitle(tStack), "author", NBT.getBookAuthor(tStack), "book", aMapping));
			return aStackToPutNBT;
		}
		
		public static ItemStack createWrittenBook(String aMapping, String aTitle, String aAuthor, ItemStack aDefaultBook, String... aPages) {
			return createWrittenBook(aMapping, aTitle, aAuthor, aDefaultBook, T, aPages);
		}
		
		public static ItemStack createWrittenBook(String aMapping, String aTitle, String aAuthor, ItemStack aDefaultBook, boolean aLogging, String... aPages) {
			if (Code.stringInvalid(aMapping)) return null;
			ItemStack rStack = BOOK_MAP.get(aMapping);
			if (rStack == null) rStack = aDefaultBook==null?Stacks.make(Items.written_book, 1, 0):Stacks.amount(1, aDefaultBook);
			NBTTagCompound rNBT = rStack.getTagCompound();
			if (rNBT != null) return Stacks.copy(rStack);
			if (Code.stringInvalid(aTitle) || Code.stringInvalid(aAuthor) || aPages.length <= 0) return null;
			rNBT = new NBTTagCompound();
	        rNBT.setString("title", aTitle);
	        rNBT.setString("author", aAuthor);
	        NBTTagList tNBTList = new NBTTagList();
	        for (byte i = 0; i < aPages.length; i++) {
		        if (i == 49 && D1) OUT.println("NOTE: Written Book has more than 50 Pages -> " + aMapping);
		        if (aPages[i].length() < 256)
		        	tNBTList.appendTag(new NBTTagString(aPages[i]));
		        else
		        	ERR.println("WARNING: String for Page of written Book too long! -> " + aPages[i]);
	        }
	        rNBT.setTag("pages", tNBTList);
	        if (aLogging) OUT.println("NOTE: Added Book to Book List  -  Mapping: '"+aMapping+"'  -  Name: '"+aTitle+"'  -  Author: '"+aAuthor+"'");
	        rStack.setTagCompound(rNBT);
	        BOOK_MAP.put(aMapping, Stacks.copy(rStack));
	        BOOK_LIST.add(aMapping);
			return Stacks.copy(rStack);
		}
		
		public static ItemStack createMaterialDictionary(OreDictMaterial aMat, ItemStack aDefaultBook, ItemStack aDefaultLargeBook) {
	        String tPage = "";
	        List<String> tBook = new ArrayListNoNulls<String>();
	        boolean temp = F;
	        int tCounter = 0;
			
        	tBook.add("===================\n"+aMat.getLocal()+"\n===================\nID: "+(aMat.mID<0?"NONE":aMat.mID)+"\nMelting: "+aMat.mMeltingPoint+" K\nBoiling: "+aMat.mBoilingPoint+" K\nPlasma: "+aMat.mPlasmaPoint+" K\n===================\nDensity:\n"+aMat.mGramPerCubicCentimeter+" g/cm3\n"+aMat.getWeight(U)+" kg/unit\n===================\n");
        	
        	//----------
        	
        	if (aMat.mComponents == null) {
        		if (aMat.contains(TD.Atomic.ELEMENT)) {
            		temp = T;
        			tPage="Atomic Structure:\nProtons: "+aMat.mProtons+"\nElectrons: " + aMat.mElectrons + "\nNeutrons: " + aMat.mNeutrons + "\nMass: "+aMat.mMass+"\n===================\n";
        			for (TagData tTag : TD.Atomic.ALL) if (tTag != TD.Atomic.ELEMENT && tTag != TD.Atomic.NONMETAL && aMat.contains(tTag)) tPage += tTag.getLocalisedNameLong() + "\n";
        		}
        	} else {
        		temp = T;
        		tPage="Components per "+aMat.mComponents.getCommonDivider() + "\n===================\n";
        		for (OreDictMaterialStack tMaterial : aMat.mComponents.getUndividedComponents()) tPage += (tMaterial.mAmount / U)+" "+tMaterial.mMaterial.getLocal()+"\n";
        	}
        	
        	if (temp) {tBook.add(tPage); temp = F;}
        	
        	//----------
        	
    		tPage="Tool Properties\n===================\n";
    		
    		if (aMat.contains(TD.Properties.HAS_TOOL_STATS)) {temp = T; tPage+="Durability:\n"+aMat.mToolDurability+"\nQuality:\n"+aMat.mToolQuality+"\nSpeed:\n"+aMat.mToolSpeed+"\nHandle:\n"+aMat.mHandleMaterial.getLocal()+"\n";}
    		for (ObjectStack<Enchantment> tEnchantment : aMat.mEnchantmentTools ) {temp = T; tPage += "Tool Enchantment:\n"  + tEnchantment.mObject.getTranslatedName((int)tEnchantment.mAmount) + "\n";}
    		for (ObjectStack<Enchantment> tEnchantment : aMat.mEnchantmentArmors) {temp = T; tPage += "Armor Enchantment:\n" + tEnchantment.mObject.getTranslatedName((int)tEnchantment.mAmount) + "\n";}
    		
        	if (temp) {tBook.add(tPage+"===================\n"); temp = F;}
        	
        	//----------
        	
    		tPage="Properties\n===================\n";
    		
    		for (TagData tTag : TD.Properties.ALL_RELEVANTS) if (aMat.contains(tTag)) {temp = T; tPage += tTag.getLocalisedNameLong() + "\n";}
    		
        	if (temp) {tBook.add(tPage); temp = F;}
        	
        	//----------
        	
    		tPage="Machine Processing\n===================\n";
    		
    		for (TagData tTag : TD.Processing.ALL_MACHINES) if (aMat.contains(tTag)) {temp = T; tPage += tTag.getLocalisedNameLong() + "\n";}
    		
        	if (temp) {tBook.add(tPage); temp = F;}
        	
        	//----------
        	
    		tPage="Materials which can be decomposed to this\n===================\n";
    		tCounter = 0;
        	for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mComponents != null && tMat.contains(TD.Compounds.DECOMPOSABLE)) {
        		for (OreDictMaterialStack tMt2 : tMat.mComponents.getUndividedComponents()) if (tMt2.mMaterial == aMat) {
                	temp=!(tCounter++%6==5);
                	tPage += tMat.getLocal()+"\n";
                    if (!temp) {
                		tBook.add(tPage);
                		tPage="Materials which can be decomposed to this\n===================\n";
                	}
        			break;
        		}
        	}
        	
            if (temp) {tBook.add(tPage); temp = F;}
        	
        	//----------
        	
    		tPage="Ore Processing\n===================\n";
    		
    		for (TagData tTag : TD.Processing.ALL_ORES) if (aMat.contains(tTag)) {temp = T; tPage += tTag.getLocalisedNameLong() + "\n";}
    		
        	if (temp) {tBook.add(tPage); temp = F;}
        	
        	//----------
        	
    		tPage="Ore Byproducts\n===================\n";
    		
    		for (OreDictMaterial tMat : aMat.mByProducts) {temp = T; tPage += tMat.getLocal() + "\n";}
    		
        	if (temp) {tBook.add(tPage); temp = F;}
        	
        	//----------
        	
    		tPage="Ores with this as Byproduct\n===================\n";
    		tCounter = 0;
        	for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mByProducts.contains(aMat)) {
            	temp=!(tCounter++%6==5);
            	tPage += tMat.getLocal()+"\n";
                if (!temp) {
            		tBook.add(tPage);
            		tPage="Ores with this as Byproduct\n===================\n";
            	}
        	}
        	
            if (temp) {tBook.add(tPage); temp = F;}
        	
        	//----------
        	
        	tPage = "Processing Data\n===================\n";
        	tPage += "Smelting:\n"		+(aMat.mTargetSmelting		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetSmelting		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetSmelting		.mAmount <= 0 ? "nothing" : aMat.mTargetSmelting	.mMaterial == aMat ? "itself" : aMat.mTargetSmelting	.mMaterial.getLocal())+"\n";
        	tPage += "Solidifying:\n"	+(aMat.mTargetSolidifying	.mAmount / U) + "." + ((int)(((double)(aMat.mTargetSolidifying	.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetSolidifying	.mAmount <= 0 ? "nothing" : aMat.mTargetSolidifying	.mMaterial == aMat ? "itself" : aMat.mTargetSolidifying	.mMaterial.getLocal())+"\n";
        	tPage += "Burning:\n"		+(aMat.mTargetBurning		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetBurning		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetBurning		.mAmount <= 0 ? "nothing" : aMat.mTargetBurning		.mMaterial == aMat ? "itself" : aMat.mTargetBurning		.mMaterial.getLocal())+"\n";
        	tPage += "Pulverising:\n"	+(aMat.mTargetPulver		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetPulver		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetPulver			.mAmount <= 0 ? "nothing" : aMat.mTargetPulver		.mMaterial == aMat ? "itself" : aMat.mTargetPulver		.mMaterial.getLocal())+"\n";
        	tPage += "Crushing:\n"		+(aMat.mTargetCrushing		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetCrushing		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetCrushing		.mAmount <= 0 ? "nothing" : aMat.mTargetCrushing	.mMaterial == aMat ? "itself" : aMat.mTargetCrushing	.mMaterial.getLocal())+"\n";
        	
        	tBook.add(tPage);
        	
        	//----------
        	
        	tPage = "Processing Data\n===================\n";
        	tPage += "Bending:\n"		+(aMat.mTargetBending		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetBending		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetBending		.mAmount <= 0 ? "nothing" : aMat.mTargetBending		.mMaterial == aMat ? "itself" : aMat.mTargetBending		.mMaterial.getLocal())+"\n";
        	tPage += "Compressing:\n"	+(aMat.mTargetCompressing	.mAmount / U) + "." + ((int)(((double)(aMat.mTargetCompressing	.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetCompressing	.mAmount <= 0 ? "nothing" : aMat.mTargetCompressing	.mMaterial == aMat ? "itself" : aMat.mTargetCompressing	.mMaterial.getLocal())+"\n";
        	tPage += "Cutting:\n"		+(aMat.mTargetCutting		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetCutting		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetCutting		.mAmount <= 0 ? "nothing" : aMat.mTargetCutting		.mMaterial == aMat ? "itself" : aMat.mTargetCutting		.mMaterial.getLocal())+"\n";
        	tPage += "Forging:\n"		+(aMat.mTargetForging		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetForging		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetForging		.mAmount <= 0 ? "nothing" : aMat.mTargetForging		.mMaterial == aMat ? "itself" : aMat.mTargetForging		.mMaterial.getLocal())+"\n";
        	tPage += "Smashing:\n"		+(aMat.mTargetSmashing		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetSmashing		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetSmashing		.mAmount <= 0 ? "nothing" : aMat.mTargetSmashing	.mMaterial == aMat ? "itself" : aMat.mTargetSmashing	.mMaterial.getLocal())+"\n";
        	
        	tBook.add(tPage);
        	
        	//----------
        	
        	tPage = "Processing Data\n===================\n";
        	tPage += "Working:\n"		+(aMat.mTargetWorking		.mAmount / U) + "." + ((int)(((double)(aMat.mTargetWorking		.mAmount % U) / (double)U) * 1000))+" "+(aMat.mTargetWorking		.mAmount <= 0 ? "nothing" : aMat.mTargetWorking		.mMaterial == aMat ? "itself" : aMat.mTargetWorking		.mMaterial.getLocal())+"\n";
        	
        	tBook.add(tPage);
        	
        	//----------
        	
        	tPage = "Thaumaturgic Data\n===================\nAspects:\n";
        	
        	if (aMat.mAspects.isEmpty()) {
        		tPage += "None\n";
        	} else {
        		for (TC_AspectStack tAspect : aMat.mAspects) tPage += tAspect.mAmount + "x " + tAspect.mAspect.mName + "\n";
        	}
        	
    		tPage += "===================\n";
        	
        	tBook.add(tPage);
        	
        	//----------
        	
        	Map<OreDictMaterial, Long> tMap;
        	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetSmelting	.mMaterial == aMat && tMat.mTargetSmelting		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetSmelting		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to smelt for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to smelt for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetBurning		.mMaterial == aMat && tMat.mTargetBurning		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetBurning		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to burn for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to burn for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
         	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetPulver		.mMaterial == aMat && tMat.mTargetPulver		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetPulver		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to pulverise for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to pulverise for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetBending		.mMaterial == aMat && tMat.mTargetBending		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetBending		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to bend for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to bend for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetCompressing	.mMaterial == aMat && tMat.mTargetCompressing	.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetCompressing	.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to compress for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to compress for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetCrushing	.mMaterial == aMat && tMat.mTargetCrushing		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetCrushing		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to crush for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to crush for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetCutting		.mMaterial == aMat && tMat.mTargetCutting		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetCutting		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to cut for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to cut for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetForging		.mMaterial == aMat && tMat.mTargetForging		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetForging		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to forge for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to forge for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetSmashing	.mMaterial == aMat && tMat.mTargetSmashing		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetSmashing		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to smash for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to smash for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
        	tMap = new HashMap<OreDictMaterial, Long>(); for (OreDictMaterial tMat : OreDictMaterial.MATERIAL_MAP.values()) if (tMat.mTargetRegistration == tMat && tMat != aMat && tMat.mTargetWorking		.mMaterial == aMat && tMat.mTargetWorking		.mAmount > 0 && !tMat.getLocal().equals(aMat.getLocal())) tMap.put(tMat, tMat.mTargetWorking		.mAmount);
        	tMap = Code.sortByValuesDescending(tMap);
        	tPage = "Resources to use in other ways for getting "+aMat.getLocal()+"\n===================\n";
        	tCounter = 0;
        	for (Entry<OreDictMaterial, Long> tEntry : tMap.entrySet()) {
        		temp=!(tCounter++%6==5);
        		tPage+=(tEntry.getValue() / U) + "." + ((int)(((double)(tEntry.getValue() % U) / (double)U) * 1000))+" from 1 "+tEntry.getKey().getLocal()+"\n";
            	if (!temp) {
        			tBook.add(tPage);
                	tPage = "Resources to use in other ways for getting "+aMat.getLocal()+"\n===================\n";
        		}
        	}
        	
        	if (temp) {tBook.add(tPage); temp=F;}
        	
         	//----------
         	
            for (IOreDictConfigurationComponent tConfig : aMat.mAlloyCreationRecipes) {
            	tPage="Alloy:\n"+aMat.getLocal()+"\n===================\nMelting: "+aMat.mMeltingPoint+" K\nBoiling: "+aMat.mBoilingPoint+" K\n===================\nComponents per "+tConfig.getCommonDivider() + "\n";
                for (OreDictMaterialStack tMt2 : tConfig.getUndividedComponents()) tPage += (tMt2.mAmount / U)+" "+tMt2.mMaterial.getLocal()+"\n";
                tBook.add(tPage);
            	break;
            }
            
         	//----------
         	
        	for (OreDictMaterial tMat : aMat.mAlloyComponentReferences) {
            	for (IOreDictConfigurationComponent tConfig : tMat.mAlloyCreationRecipes) {
            		for (OreDictMaterialStack tMatStack : tConfig.getUndividedComponents()) {
            			if (tMatStack.mMaterial == aMat) {
                    		tPage="Alloy:\n"+tMat.getLocal()+"\n===================\nMelting: "+tMat.mMeltingPoint+" K\nBoiling: "+tMat.mBoilingPoint+" K\n===================\nComponents per "+tConfig.getCommonDivider() + "\n";
                    		for (OreDictMaterialStack tMt2 : tConfig.getUndividedComponents()) tPage += (tMt2.mAmount / U)+" "+tMt2.mMaterial.getLocal()+"\n";
                    	 	tBook.add(tPage);
            				break;
            			}
            		}
            	}
            }
        	
        	//----------
        	
        	if (aMat.mDescription != null) for (int i = 0, j = 0; i < aMat.mDescription.length; i++) if (Code.stringValid(aMat.mDescription[i])) tBook.add("Description Pg "+(++j)+"\n===================\n" + aMat.mDescription[i]);
        	
        	//----------
        	
        	MATERIAL_DICTIONARIES.add("Material_Dictionary_"+aMat.mNameInternal);
        	
        	return Stacks.copy(aMat.mDictionaryBook = createWrittenBook("Material_Dictionary_"+aMat.mNameInternal, aMat.getLocal(), "Material Dictionary Foundation", tBook.size()<=50?(aDefaultBook!=null?aDefaultBook:ItemsGT.sMultiItemBooks==null?NI:Stacks.make(ItemsGT.sMultiItemBooks, 1, 32002)):(aDefaultLargeBook!=null?aDefaultLargeBook:ItemsGT.sMultiItemBooks==null?NI:Stacks.make(ItemsGT.sMultiItemBooks, 1, 32003)), F, tBook.toArray(ZL_STRING)));
		}
	}
	
	public static class Stacks {
		public static boolean debugItem(ItemStack aStack) {
			return IL.IC2_Debug.equal(aStack, T, T);
		}
		
		public static ItemStack update(ItemStack aStack) {
			return valid(aStack)?update_(aStack):aStack;
		}
		public static ItemStack update_(ItemStack aStack) {
			if (aStack.hasTagCompound() && aStack.getTagCompound().hasNoTags()) aStack.setTagCompound(null);
			if (aStack.getItem() instanceof IItemUpdatable) ((IItemUpdatable)aStack.getItem()).updateItemStack(aStack);
			return aStack;
		}
		
		public static boolean inList(Collection<ItemStack> aList, ItemStack aStack, boolean aTrueIfListEmpty, boolean aInvertFilter) {
			if (aStack == null || aStack.stackSize < 1) return F;
			if (aList == null) return aTrueIfListEmpty;
			while (aList.contains(null)) aList.remove(null);
			if (aList.size() < 1) return aTrueIfListEmpty;
			Iterator<ItemStack> tIterator = aList.iterator();
			ItemStack tStack = null;
			while (tIterator.hasNext()) if ((tStack = tIterator.next())!= null && equal(aStack, tStack)) return !aInvertFilter;
			return aInvertFilter;
		}
		
		public static ItemStack set(Object aSetStack, Object aToStack) {
			if (invalid(aSetStack) || invalid(aToStack)) return null;
			((ItemStack)aSetStack).func_150996_a(((ItemStack)aToStack).getItem());
			((ItemStack)aSetStack).stackSize = ((ItemStack)aToStack).stackSize;
			meta((ItemStack)aSetStack, meta((ItemStack)aToStack));
			((ItemStack)aSetStack).setTagCompound(((ItemStack)aToStack).getTagCompound());
			return (ItemStack)aSetStack;
		}
		
		public static ItemStack container(ItemStack aStack, boolean aCheckIFluidContainerItems) {
			if (invalid(aStack)) return null;
			if (aStack.getItem().hasContainerItem(aStack)) return aStack.getItem().getContainerItem(aStack);
			/** These are all special Cases, in which it is intended to have only GT Blocks outputting those Container Items */
			if (IL.Cell_Empty.equal(aStack, F, T)) return null;
			
			if (aCheckIFluidContainerItems && aStack.getItem() instanceof IFluidContainerItem && ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack) > 0) {
				ItemStack tStack = amount(1, aStack);
				((IFluidContainerItem)aStack.getItem()).drain(tStack, Integer.MAX_VALUE, T);
				if (!equal(aStack, tStack)) return tStack;
				return null;
			}
			
			if (IL.IC2_ForgeHammer.equal(aStack, T, T) || IL.IC2_WireCutter.equal(aStack, T, T)) return copyMeta(meta(aStack) + 1, aStack);
			return null;
		}
		
		public static ItemStack container(ItemStack aStack, boolean aCheckIFluidContainerItems, int aStacksize) {
			return amount(aStacksize, container(aStack, aCheckIFluidContainerItems));
		}
		
		public static boolean equal(ItemStack aStack1, ItemStack aStack2) {
			return equal(aStack1, aStack2, F);
		}
		
		public static boolean equalTools(ItemStack aStack1, ItemStack aStack2, boolean aIgnoreNBT) {
			return aStack1 != null && aStack2 != null && equalTools_(aStack1, aStack2, aIgnoreNBT);
		}
		
		public static boolean equalTools_(ItemStack aStack1, ItemStack aStack2, boolean aIgnoreNBT) {
			return aStack1.getItem() == aStack2.getItem() && (aIgnoreNBT || aStack1.getItem() instanceof IItemGTContainerTool || ((aStack1.getTagCompound() == null) == (aStack2.getTagCompound() == null)) && (aStack1.getTagCompound() == null || aStack1.getTagCompound().equals(aStack2.getTagCompound()))) && (meta(aStack1) == meta(aStack2) || meta(aStack1) == CS.W || meta(aStack2) == CS.W);
		}
		
		public static boolean equal(ItemStack aStack1, ItemStack aStack2, boolean aIgnoreNBT) {
			return aStack1 != null && aStack2 != null && equal_(aStack1, aStack2, aIgnoreNBT);
		}
		
		public static boolean equal_(ItemStack aStack1, ItemStack aStack2, boolean aIgnoreNBT) {
			return aStack1.getItem() == aStack2.getItem() && (aIgnoreNBT || ((aStack1.getTagCompound() == null) == (aStack2.getTagCompound() == null)) && (aStack1.getTagCompound() == null || aStack1.getTagCompound().equals(aStack2.getTagCompound()))) && (meta(aStack1) == meta(aStack2) || meta(aStack1) == CS.W || meta(aStack2) == CS.W);
		}
		
		public static short id(Item aItem) {
			return aItem==null?0:(short)Item.getIdFromItem(aItem);
		}
		
		public static short id(ItemStack aStack) {
			return aStack==null?0:id(aStack.getItem());
		}
		
		public static Item item(ItemStack aStack) {
			return aStack==null?null:aStack.getItem();
		}
		
		public static short meta(ItemStack aStack) {
			return (short)Items.feather.getDamage(aStack);
		}
		
		public static ItemStack meta(ItemStack aStack, long aMeta) {
			Items.feather.setDamage(aStack, (short)aMeta);
			return aStack;
		}
		
		public static boolean rotten(ItemStack aStack) {
			if (invalid(aStack)) return F;
			if (aStack.getItem() instanceof MultiItemRandom) {
				IFoodStat tStat = ((MultiItemRandom)aStack.getItem()).mFoodStats.get(meta(aStack));
				return tStat != null && tStat.isRotten((MultiItemRandom)aStack.getItem(), aStack, null);
			}
			return aStack.getItem() == Items.rotten_flesh;
		}
		
		public static int food(ItemStack aStack) {
			if (invalid(aStack)) return 0;
			if (aStack.getItem() instanceof ItemFood) return ((ItemFood)aStack.getItem()).func_150905_g(aStack);
			if (aStack.getItem() instanceof MultiItemRandom) {
				IFoodStat tStat = ((MultiItemRandom)aStack.getItem()).mFoodStats.get(meta(aStack));
				return tStat == null ? 0 : tStat.getFoodLevel((MultiItemRandom)aStack.getItem(), aStack, null);
			}
			return 0;
		}
		
		public static float saturation(ItemStack aStack) {
			if (invalid(aStack)) return 0;
			if (aStack.getItem() instanceof ItemFood) return ((ItemFood)aStack.getItem()).func_150906_h(aStack);
			if (aStack.getItem() instanceof MultiItemRandom) {
				IFoodStat tStat = ((MultiItemRandom)aStack.getItem()).mFoodStats.get(meta(aStack));
				return tStat == null ? 0 : tStat.getSaturation((MultiItemRandom)aStack.getItem(), aStack, null);
			}
			return 0;
		}
		
		/** @param aValue the Value of this Stack, when burning inside a Furnace (200 = 1 Burn Process = 5000 HU, max = 32767 (that is 819175 HU)), limited to Short because the vanilla Furnace otherwise can't handle it properly, stupid Mojang... */
		public static ItemStack fuel(ItemStack aStack, short aValue) {aStack.setTagCompound(NBT.getNBTShort(aStack.getTagCompound(), NBT_FUEL_VALUE, aValue)); return aStack;}
		/** @return the Value of this Stack, when burning inside a Furnace (200 = 1 Burn Process = 5000 HU, max = 32767 (that is 819175 HU)), limited to Short because the vanilla Furnace otherwise can't handle it properly, stupid Mojang... */
		public static long fuel(ItemStack aStack) {
			if (invalid(aStack)) return 0;
			long rFuelValue = GameRegistry.getFuelValue(aStack);
			if (rFuelValue > 0) return rFuelValue;
            Item tItem = aStack.getItem();
            if (tItem instanceof ItemBlock && Block.getBlockFromItem(tItem) != NB) {
                Block tBlock = Block.getBlockFromItem(tItem);
                if (tBlock == Blocks.sapling) return 100;
                if (tBlock == Blocks.wooden_slab) return 150;
                if (tBlock == Blocks.coal_block) return 16000;
                if (tBlock.getMaterial() == Material.wood) return 300;
            }
            if (tItem instanceof ItemTool && ((ItemTool)tItem).getToolMaterialName().equals("WOOD")) return 200;
            if (tItem instanceof ItemSword && ((ItemSword)tItem).getToolMaterialName().equals("WOOD")) return 200;
            if (tItem instanceof ItemHoe && ((ItemHoe)tItem).getToolMaterialName().equals("WOOD")) return 200;
            if (tItem == Items.stick) return 100;
            if (tItem == Items.coal) return 1600;
            if (tItem == Items.blaze_rod) return 2400;
            if (tItem == Items.lava_bucket) return 20000;
            return 0;
		}
		
		
		private static final Map<String, ItemStack> sIC2ItemMap = new HashMap<String, ItemStack>();
		public static ItemStack makeIC2(String aItem, long aAmount, ItemStack aReplacement) {if (Code.stringInvalid(aItem) || !GT_API.sAllowCrossModItemAccess) return null; if (!sIC2ItemMap.containsKey(aItem)) try {ItemStack tStack = IC2Items.getItem(aItem); sIC2ItemMap.put(aItem, tStack); if (tStack == null && D1) ERR.println(aItem + " is not found in the IC2 Items!");} catch (Throwable e) {/*Do nothing*/} return amount(aAmount, sIC2ItemMap.get(aItem), aReplacement);}
		public static ItemStack makeIC2(String aItem, long aAmount, int aMeta, ItemStack aReplacement) {ItemStack rStack = makeIC2(aItem, aAmount, aReplacement); if (rStack == null) return null; meta(rStack, aMeta); return rStack;}
		public static ItemStack makeIC2(String aItem, long aAmount, int aMeta) {return makeIC2(aItem, aAmount, aMeta, null);}
		public static ItemStack makeIC2(String aItem, long aAmount) {return makeIC2(aItem, aAmount, null);}
		
		public static Block block(ModData aModID, String aBlock) {return block(make(aModID, aBlock, 1, null));}
		public static Block block(ModData aModID, String aBlock, Block aReplacement) {Block rBlock = block(aModID, aBlock); return rBlock == NB ? aReplacement : rBlock;}
		public static Block block(String aModID, String aBlock) {return block(make(aModID, aBlock, 1, null));}
		public static Block block(String aModID, String aBlock, Block aReplacement) {Block rBlock = block(aModID, aBlock); return rBlock == NB ? aReplacement : rBlock;}
		
		public static ItemStack make(ModData aModID, String aItem, long aAmount) {return make(aModID, aItem, aAmount, null);}
		public static ItemStack make(ModData aModID, String aItem, long aAmount, ItemStack aReplacement) {if (Code.stringInvalid(aItem) || !GT_API.sAllowCrossModItemAccess) return null; if (aItem.length()>5&&aItem.charAt(0)=='t'&&aItem.charAt(1)=='i'&&aItem.charAt(2)=='l'&&aItem.charAt(3)=='e'&&aItem.charAt(4)=='.') return amount(aAmount, GameRegistry.findItemStack(aModID.mID, aItem, (int)aAmount), GameRegistry.findItemStack(aModID.mID, aItem.substring(5), (int)aAmount), aReplacement); return amount(aAmount, GameRegistry.findItemStack(aModID.mID, aItem, (int)aAmount), aReplacement);}
		public static ItemStack make(ModData aModID, String aItem, long aAmount, int aMeta) {ItemStack rStack = make(aModID, aItem, aAmount); if (rStack == null) return null; meta(rStack, aMeta); return rStack;}
		public static ItemStack make(ModData aModID, String aItem, long aAmount, int aMeta, ItemStack aReplacement) {ItemStack rStack = make(aModID, aItem, aAmount, aReplacement); if (rStack == null) return null; meta(rStack, aMeta); return rStack;}
		public static ItemStack make(String aModID, String aItem, long aAmount) {return make(aModID, aItem, aAmount, null);}
		public static ItemStack make(String aModID, String aItem, long aAmount, ItemStack aReplacement) {if (Code.stringInvalid(aItem) || !GT_API.sAllowCrossModItemAccess) return null; if (aItem.length()>5&&aItem.charAt(0)=='t'&&aItem.charAt(1)=='i'&&aItem.charAt(2)=='l'&&aItem.charAt(3)=='e'&&aItem.charAt(4)=='.') return amount(aAmount, GameRegistry.findItemStack(aModID, aItem, (int)aAmount), GameRegistry.findItemStack(aModID, aItem.substring(5), (int)aAmount), aReplacement); return amount(aAmount, GameRegistry.findItemStack(aModID, aItem, (int)aAmount), aReplacement);}
		public static ItemStack make(String aModID, String aItem, long aAmount, int aMeta) {ItemStack rStack = make(aModID, aItem, aAmount); if (rStack == null) return null; meta(rStack, aMeta); return rStack;}
		public static ItemStack make(String aModID, String aItem, long aAmount, int aMeta, ItemStack aReplacement) {ItemStack rStack = make(aModID, aItem, aAmount, aReplacement); if (rStack == null) return null; meta(rStack, aMeta); return rStack;}
		public static ItemStack make(long aItemID, long aStacksize, long aMetaData) {return aItemID==0?null:make(Item.getItemById((int)aItemID), aStacksize, aMetaData);}
		public static ItemStack make(Item aItem, long aStacksize, long aMetaData) {return aItem == null ? null : make(new ItemStack(aItem, Code.bindInt(aStacksize), (int)aMetaData), null);}
		public static ItemStack make(Block aBlock, long aStacksize, long aMetaData) {return aBlock == null || aBlock == NB ? null : make(new ItemStack(aBlock, Code.bindInt(aStacksize), (int)aMetaData), null);}
		public static ItemStack make(long aItemID, long aStacksize, long aMetaData, NBTTagCompound aNBT) {return aItemID==0?null:make(Item.getItemById((int)aItemID), aStacksize, aMetaData, aNBT);}
		public static ItemStack make(Item aItem, long aStacksize, long aMetaData, NBTTagCompound aNBT) {return aItem == null ? null : make(new ItemStack(aItem, Code.bindInt(aStacksize), (int)aMetaData), aNBT);}
		public static ItemStack make(Block aBlock, long aStacksize, long aMetaData, NBTTagCompound aNBT) {return aBlock == null || aBlock == NB ? null : make(new ItemStack(aBlock, Code.bindInt(aStacksize), (int)aMetaData), aNBT);}
		public static ItemStack make(ItemStack aStack, NBTTagCompound aNBT) {return make(aStack, null, aNBT);}
		public static ItemStack make(ItemStackContainer aStack, NBTTagCompound aNBT) {return make(aStack, null, aNBT);}
		public static ItemStack make(long aItemID, long aStacksize, long aMetaData, String aName) {return aItemID==0?null:make(Item.getItemById((int)aItemID), aStacksize, aMetaData, aName);}
		public static ItemStack make(Item aItem, long aStacksize, long aMetaData, String aName) {return aItem == null ? null : make(new ItemStack(aItem, Code.bindInt(aStacksize), (int)aMetaData), aName, null);}
		public static ItemStack make(Block aBlock, long aStacksize, long aMetaData, String aName) {return aBlock == null || aBlock == NB ? null : make(new ItemStack(aBlock, Code.bindInt(aStacksize), (int)aMetaData), aName, null);}
		public static ItemStack make(long aItemID, long aStacksize, long aMetaData, String aName, NBTTagCompound aNBT) {return aItemID==0?null:make(Item.getItemById((int)aItemID), aStacksize, aMetaData, aName, aNBT);}
		public static ItemStack make(Item aItem, long aStacksize, long aMetaData, String aName, NBTTagCompound aNBT) {return aItem == null ? null : make(new ItemStack(aItem, Code.bindInt(aStacksize), (int)aMetaData), aName, aNBT);}
		public static ItemStack make(Block aBlock, long aStacksize, long aMetaData, String aName, NBTTagCompound aNBT) {return aBlock == null || aBlock == NB ? null : make(new ItemStack(aBlock, Code.bindInt(aStacksize), (int)aMetaData), aName, aNBT);}
		public static ItemStack make(ItemStack aStack, String aName, NBTTagCompound aNBT) {if (aStack == null) return null; aStack = aStack.copy(); aStack.setTagCompound(aNBT); if (aName != null) aStack.setStackDisplayName(aName); return aStack;}
		public static ItemStack make(ItemStackContainer aStack, String aName, NBTTagCompound aNBT) {if (aStack == null) return null; ItemStack rStack = aStack.toStack(); if (rStack == null) return null; rStack.setTagCompound(aNBT); if (aName != null) rStack.setStackDisplayName(aName); return rStack;}
		
		public static ItemStack[] copyArray(Object... aStacks) {
			ItemStack[] rStacks = new ItemStack[aStacks.length];
			for (int i = 0; i < aStacks.length; i++) rStacks[i] = copy(aStacks[i]);
			return rStacks;
		}
		
		public static ItemStack copy(Object... aStacks) {
			for (Object tStack : aStacks) if (valid(tStack)) return ((ItemStack)tStack).copy();
			return null;
		}
		
		public static ItemStack amount(long aAmount, Object... aStacks) {
			ItemStack rStack = copy(aStacks);
			if (invalid(rStack)) return null;
			rStack.stackSize = (int)aAmount;
			return rStack;
		}
		
		public static ItemStack copyAmount(long aAmount, Object... aStacks) {
			return amount(aAmount, aStacks);
		}
		
		public static ItemStack copyMeta(long aMetaData, Object... aStacks) {
			ItemStack rStack = copy(aStacks);
			if (invalid(rStack)) return null;
			return meta(rStack, aMetaData);
		}
		
		public static ItemStack copyAmountAndMeta(long aAmount, long aMetaData, Object... aStacks) {
			ItemStack rStack = amount(aAmount, aStacks);
			if (invalid(rStack)) return null;
			return meta(rStack, aMetaData);
		}
		
		/**
		 * returns a copy of an ItemStack with its StackSize being multiplied by aMultiplier
		 */
		public static ItemStack mul(long aMultiplier, Object... aStacks) {
			ItemStack rStack = copy(aStacks);
			if (rStack == null) return null;
			rStack.stackSize *= aMultiplier;
			return rStack;
		}
		
		/**
		 * returns a copy of an ItemStack with its StackSize being divided by aDivider
		 */
		public static ItemStack div(long aDivider, Object... aStacks) {
			ItemStack rStack = copy(aStacks);
			if (rStack == null) return null;
			rStack.stackSize /= aDivider;
			return rStack;
		}
		
		public static int toInt(ItemStack aStack) {
			if (invalid(aStack)) return 0;
			return id(aStack) | (meta(aStack)<<16);
		}
		
		public static int toIntWildcard(ItemStack aStack) {
			if (invalid(aStack)) return 0;
			return id(aStack) | (W<<16);
		}
		
		public static ItemStack toStack(int aStack) {
		    Item tItem = Item.getItemById(aStack&(~0>>>16));
			if (tItem != null) return make(tItem, 1, aStack>>>16);
			return null;
		}
		
		public static Integer[] toIntegerArray(ItemStack... aStacks) {
			Integer[] rArray = new Integer[aStacks.length];
			for (int i = 0; i < rArray.length; i++) rArray[i] = toInt(aStacks[i]);
			return rArray;
		}
		
		public static int[] toIntArray(ItemStack... aStacks) {
			int[] rArray = new int[aStacks.length];
			for (int i = 0; i < rArray.length; i++) rArray[i] = toInt(aStacks[i]);
			return rArray;
		}
		
		public static Block block(Object aStack) {
			if (invalid(aStack)) return NB;
			return Block.getBlockFromItem(((ItemStack)aStack).getItem());
		}
		
		public static Block block_(Object aStack) {
			return Block.getBlockFromItem(((ItemStack)aStack).getItem());
		}
		
		public static boolean valid(Object aStack) {
			return aStack != null &&  (aStack instanceof ItemStack) && ((ItemStack)aStack).getItem() != null && ((ItemStack)aStack).stackSize >= 0;
		}
		
		public static boolean invalid(Object aStack) {
			return aStack == null || !(aStack instanceof ItemStack) || ((ItemStack)aStack).getItem() == null || ((ItemStack)aStack).stackSize <  0;
		}
		
		public static String configName(ItemStack aStack) {
			if (invalid(aStack)) return "";
			Object rName = OreDictManager.INSTANCE.getAssociation_(aStack, T);
			if (rName != null) return rName.toString();
			try {if (Code.stringValid(rName = aStack.getUnlocalizedName())) return rName.toString();} catch (Throwable e) {/*Do nothing*/}
			return aStack.getItem() + "." + meta(aStack);
		}
		
		public static String configNames(ItemStack... aStacks) {
			String rString = "";
			for (ItemStack tStack : aStacks) rString += (tStack == null ? "null;" : configName(tStack) + ";");
			return rString;
		}
		
		public static String names(ItemStack... aStacks) {
			String rString = "";
			for (ItemStack tStack : aStacks) rString += (tStack == null ? "null; " : tStack.getDisplayName() + "; ");
			return rString;
		}
		
		public static String namesAndSizes(ItemStack... aStacks) {
			String rString = "";
			for (ItemStack tStack : aStacks) rString += (tStack == null ? "null; " : tStack.getDisplayName() + " " + tStack.stackSize + "; ");
			return rString;
		}
		
		public static void hide(Item aItem) {
			hide(aItem, W);
		}
		
		public static void hide(Item aItem, long aMetaData) {
			hide(make(aItem, 1, aMetaData));
		}
		
		public static void hide(Block aBlock) {
			hide(aBlock, W);
		}
		
		public static void hide(Block aBlock, long aMetaData) {
			hide(make(aBlock, 1, aMetaData));
		}
		
		public static void hide(ItemStack aStack) {
			if (aStack != null) try {codechicken.nei.api.API.hideItem(aStack);} catch(Throwable e) {/**/}
		}
		
		/**
		 * Loads an ItemStack properly.
		 */
		public static ItemStack load(NBTTagCompound aNBT, String aTagName) {
			return load(aNBT.getCompoundTag(aTagName));
		}
		
		/**
		 * Loads an ItemStack properly.
		 */
		public static ItemStack load(NBTTagCompound aNBT) {
			if (aNBT == null) return null;
			ItemStack rStack = make(Item.getItemById(aNBT.getShort("id")), aNBT.getInteger("Count"), aNBT.getShort("Damage"), aNBT.hasKey("tag", 10)?aNBT.getCompoundTag("tag"):null);
			if (rStack == null) return null;
			if (rStack.getItem().getClass().getName().startsWith("ic2.core.migration")) rStack.getItem().onUpdate(rStack, DW, null, 0, F);
			return update(OM.get_(rStack));
		}
		
		/**
		 * Saves an ItemStack properly.
		 */
		public static NBTTagCompound save(NBTTagCompound aNBT, String aTagName, ItemStack aStack) {
			NBTTagCompound rNBT = save(aStack);
			if (rNBT != null) aNBT.setTag(aTagName, rNBT);
			return rNBT;
		}
		
		/**
		 * Saves an ItemStack properly.
		 */
		public static NBTTagCompound save(ItemStack aStack) {
			if (invalid(aStack)) return null;
			NBTTagCompound rNBT = new NBTTagCompound();
			aStack = OM.get_(aStack);
			rNBT.setShort("id", (short)Item.getIdFromItem(aStack.getItem()));
			NBT.setNumber(rNBT, "Count", aStack.stackSize);
	        rNBT.setShort("Damage", meta(aStack));
	        if (aStack.hasTagCompound()) rNBT.setTag("tag", aStack.getTagCompound());
			return rNBT;
		}
	}
	
	public static class Code {
		/** Note: Does not work on huge amounts of Bytes. */
		public static byte averageBytes(byte... aBytes) {
			if (aBytes == null || aBytes.length <= 0) return 0;
			long rValue = 0;
			for (byte aByte : aBytes) rValue += aByte;
			return (byte)(rValue / aBytes.length);
		}
		
		/** Note: Does not work on huge amounts of Bytes. */
		public static byte averageUnsignedBytes(byte... aBytes) {
			if (aBytes == null || aBytes.length <= 0) return 0;
			long rValue = 0;
			for (byte aByte : aBytes) rValue += unsignB(aByte);
			return (byte)(rValue / aBytes.length);
		}
		
		/** Note: Does not work on huge amounts of Bytes. */
		public static short averageShorts(short... aShorts) {
			if (aShorts == null || aShorts.length <= 0) return 0;
			long rValue = 0;
			for (short aShort : aShorts) rValue += aShort;
			return (short)(rValue / aShorts.length);
		}
		
		/** Note: Does not work on huge amounts of Shorts. */
		public static short averageUnsignedShorts(short... aShorts) {
			if (aShorts == null || aShorts.length <= 0) return 0;
			long rValue = 0;
			for (short aShort : aShorts) rValue += unsignS(aShort);
			return (short)(rValue / aShorts.length);
		}
		
		/** Note: Does not work on huge amounts of Integers. */
		public static int averageInts(int... aInts) {
			if (aInts == null || aInts.length <= 0) return 0;
			long rValue = 0;
			for (int aInt : aInts) rValue += aInt;
			return (int)(rValue / aInts.length);
		}
		
		/** Note: Does not work on huge amounts of Integers. */
		public static int averageUnsignedInts(int... aInts) {
			if (aInts == null || aInts.length <= 0) return 0;
			long rValue = 0;
			for (int aInt : aInts) rValue += unsignI(aInt);
			return (int)(rValue / aInts.length);
		}
		
		/** Note: Does not work on huge amounts of Longs. */
		public static long averageLongs(long... aLongs) {
			if (aLongs == null || aLongs.length <= 0) return 0;
			long rValue = 0;
			for (long aLong : aLongs) rValue += aLong;
			return rValue / aLongs.length;
		}
		
		public static int roundDown(double aNumber) {
			int rRounded = (int)aNumber;
			return rRounded > aNumber ? rRounded-1 : rRounded;
		}
		
		/** @return an unsigned representation of this Byte. */
		public static short unsignB(byte aByte) {
			return aByte < 0 ? (short)(aByte + 256) : aByte;
		}
		
		/** @return an unsigned representation of this Short. */
		public static int unsignS(short aShort) {
			return aShort < 0 ? aShort + 65536 : aShort;
		}
		
		/** @return an unsigned representation of this Integer. */
		public static long unsignI(int aInteger) {
			return aInteger < 0 ? aInteger + 4294967296L : aInteger;
		}
		
		public static byte toByteS(short aValue, int aIndex) {return (byte)(0xff & (aValue >> (aIndex<<3)));}
		public static byte toByteI(int   aValue, int aIndex) {return (byte)(0xff & (aValue >> (aIndex<<3)));}
		public static byte toByteL(long  aValue, int aIndex) {return (byte)(0xff & (aValue >> (aIndex<<3)));}
		
		public static short combine(byte aValue1, byte aValue2)																						{return (short)((0xff & aValue1) | (0xff & aValue2) << 8);}
		public static int   combine(byte aValue1, byte aValue2, byte aValue3, byte aValue4)															{return         (0xff & aValue1) | (0xff & aValue2) << 8 | (0xff & aValue3) << 16 | (0xff & aValue4) << 24;}
		public static long  combine(byte aValue1, byte aValue2, byte aValue3, byte aValue4, byte aValue5, byte aValue6, byte aValue7, byte aValue8)	{return         (0xff & aValue1) | (0xff & aValue2) << 8 | (0xff & aValue3) << 16 | (0xff & aValue4) << 24 | ((long)(0xff & aValue5)) << 32 | ((long)(0xff & aValue6)) << 40 | ((long)(0xff & aValue7)) << 48 | ((long)(0xff & aValue8)) << 56;}
		
		public static long getBits(boolean... aBits) {
			long rBits = 0;
			for (int i = 0; i < 64 && i < aBits.length; i++) if (aBits[i]) rBits |= (1 << i);
			return rBits;
		}
		
		public static boolean[] getBitsB(byte aBits) {
			boolean[] rBits = new boolean[8];
			for (int i = 0; i < rBits.length; i++) if ((aBits & (1 << i)) != 0) rBits[i] = T;
			return rBits;
		}
		
		public static boolean[] getBitsS(short aBits) {
			boolean[] rBits = new boolean[16];
			for (int i = 0; i < rBits.length; i++) if ((aBits & (1 << i)) != 0) rBits[i] = T;
			return rBits;
		}
		
		public static boolean[] getBitsI(int aBits) {
			boolean[] rBits = new boolean[32];
			for (int i = 0; i < rBits.length; i++) if ((aBits & (1 << i)) != 0) rBits[i] = T;
			return rBits;
		}
		
		public static boolean[] getBitsL(long aBits) {
			boolean[] rBits = new boolean[64];
			for (int i = 0; i < rBits.length; i++) if ((aBits & (1 << i)) != 0) rBits[i] = T;
			return rBits;
		}
		
		public static ItemStack toStack(int aStack) {
		    Item tItem = Item.getItemById(aStack&(~0>>>16));
			if (tItem != null) return Stacks.make(tItem, 1, aStack>>>16);
			return null;
		}
		
		/** Converts a Number to a String */
	    public static String makeString(long aNumber) {
	    	String tString = "";
	    	boolean temp = T, negative = F;
	    	
	    	if (aNumber<0) {
	    		aNumber *= -1;
	    		negative = T;
	    	}
	    	
	    	for (long i = 1000000000000000000L; i > 0; i /= 10) {
	    		long tDigit = (aNumber/i)%10;
				if ( temp && tDigit != 0) temp = F;
				if (!temp) {
					tString += tDigit;
					if (i != 1) for (long j = i; j > 0; j /= 1000) if (j == 1) tString += ",";
				}
	    	}
	    	
	    	if (tString.equals("")) tString = "0";
	    	
	    	return negative?"-"+tString:tString;
	    }
	    
		public static <E> boolean contains(E aTarget, E... aArray) {
			if (aArray != null) for (E tValue : aArray) if (tValue == aTarget || (tValue != null && aTarget != null && tValue.equals(aTarget))) return T;
			return F;
		}
		
		public static boolean containsBoolean(boolean aTarget, boolean... aArray) {
			if (aArray != null) for (boolean tValue : aArray) if (tValue == aTarget) return T;
			return F;
		}
		
		public static <E> boolean containsSomething(E... aArray) {
			if (aArray != null) for (Object tObject : aArray) if (tObject != null) return T;
			return F;
		}
		
		public static <E> E[] makeArray(E[] rArray, E... aArray) {
			for (int i = 0; i < rArray.length && i < aArray.length; i++) rArray[i] = aArray[i];
			return rArray;
		}
		
		public static <E> long getNonNulls(E... aArray) {
			long rAmount = 0;
			if (aArray != null) for (Object tObject : aArray) if (tObject != null) rAmount++;
			return rAmount;
		}
		
		public static <E> ArrayList<E> getWithoutNulls(E... aArray) {
			if (aArray == null) return new ArrayListNoNulls<E>();
			ArrayList<E> rList = new ArrayListNoNulls<E>(Arrays.asList(aArray));
			return rList;
		}
		
		public static <E> ArrayList<E> getWithoutTrailingNulls(E... aArray) {
			if (aArray == null) return new ArrayList<E>(1);
			ArrayList<E> rList = new ArrayList<E>(Arrays.asList(aArray));
			for (int i = rList.size() - 1; i >= 0 && rList.get(i) == null;) rList.remove(i--);
			return rList;
		}
		
		private static final DateFormat sDateFormat = DateFormat.getInstance();
	    public static String dateAndTime() {
	    	return sDateFormat.format(new Date());
	    }
	    
		public static byte tier(long aSize) {
			return tierMax(aSize);
		}
		
		public static byte tierMax(long aSize) {
			byte i = -1;
			aSize = Math.abs(aSize);
			while (++i < V.length) if (aSize <= V[i]) return i;
			return i;
		}
		
		public static byte tierMin(long aSize) {
			byte i = -1;
			aSize = Math.abs(aSize);
			while (++i < V.length) if (aSize < V[i]) return (byte)Math.max(0, i-1);
			return --i;
		}
		
		public static boolean haveOneCommonElement(Iterable aCollection1, Collection aCollection2) {
			if (aCollection1 == aCollection2) return T;
			for (Object tObject : aCollection1) if (aCollection2.contains(tObject)) return T;
			return F;
		}
		
	    /** re-maps all Keys of a Map after the Keys were weakened. */
		public static <X, Y> Map<X, Y> reMap(Map<X, Y> aMap) {
			Map<X, Y> tMap = new HashMap<X, Y>();
			tMap.putAll(aMap);
			aMap.clear();
			aMap.putAll(tMap);
			return aMap;
		}
		
		/** Why the fuck do neither Java nor Guava have a Function to do this? */
	    public static <X, Y extends Comparable> LinkedHashMap<X,Y> sortByValuesAcending(Map<X,Y> aMap) {
	        List<Map.Entry<X,Y>> tEntrySet = new LinkedList<Map.Entry<X,Y>>(aMap.entrySet());
	        Collections.sort(tEntrySet, new Comparator<Map.Entry<X,Y>>() {@Override public int compare(Entry<X, Y> aValue1, Entry<X, Y> aValue2) {return aValue1.getValue().compareTo(aValue2.getValue());}});
	        LinkedHashMap<X,Y> rMap = new LinkedHashMap<X,Y>();
	        for (Map.Entry<X,Y> tEntry : tEntrySet) rMap.put(tEntry.getKey(), tEntry.getValue());
	        return rMap;
	    }
	    
		/** Why the fuck do neither Java nor Guava have a Function to do this? */
	    public static <X, Y extends Comparable> LinkedHashMap<X,Y> sortByValuesDescending(Map<X,Y> aMap) {
	        List<Map.Entry<X,Y>> tEntrySet = new LinkedList<Map.Entry<X,Y>>(aMap.entrySet());
	        Collections.sort(tEntrySet, new Comparator<Map.Entry<X,Y>>() {@Override public int compare(Entry<X, Y> aValue1, Entry<X, Y> aValue2) {return -aValue1.getValue().compareTo(aValue2.getValue());}});
	        LinkedHashMap<X,Y> rMap = new LinkedHashMap<X,Y>();
	        for (Map.Entry<X,Y> tEntry : tEntrySet) rMap.put(tEntry.getKey(), tEntry.getValue());
	        return rMap;
	    }
	    
		public static <E> E selectInList(long aIndex, E aReplacement, List<E> aList) {
			if (aList == null || aList.isEmpty()) return aReplacement;
			if (aList.size() <= aIndex) return aList.get(aList.size() - 1);
			if (aIndex < 0) return aList.get(0);
			return aList.get((int)aIndex);
		}
		
		public static <E> E selectInArray(long aIndex, E aReplacement, E... aArray) {
			if (aArray == null || aArray.length == 0) return aReplacement;
			if (aArray.length <= aIndex) return aArray[aArray.length - 1];
			if (aIndex < 0) return aArray[0];
			return aArray[(int)aIndex];
		}
		
		public static boolean inArray(Object aObject, Object... aObjects) {
			return inList(aObject, Arrays.asList(aObjects));
		}
		
		public static boolean inList(Object aObject, Collection aObjects) {
			if (aObjects == null) return F;
			return aObjects.contains(aObject);
		}
		
		public static final int[][] ASCENDING_ARRAYS = new int[256][];
		
		public static int[] getAscendingArray(int aLength) {
			if (aLength < 0) return ZL_INTEGER;
			if (aLength < ASCENDING_ARRAYS.length) {
				if (ASCENDING_ARRAYS[aLength] == null) {
					ASCENDING_ARRAYS[aLength] = new int[aLength];
					for (int i = 0; i < aLength; i++) ASCENDING_ARRAYS[aLength][i] = i;
				}
				return ASCENDING_ARRAYS[aLength];
			}
			int[] rArray = new int[aLength];
			for (int i = 0; i < aLength; i++) rArray[i] = i;
			return rArray;
		}
		
		public static boolean stringValid(Object aString) {
			return aString != null && !aString.toString().isEmpty();
		}
		
		public static boolean stringInvalid(Object aString) {
			return aString == null || aString.toString().isEmpty();
		}
		
		public static byte side(ForgeDirection aDirection) {
			return (byte)(aDirection==null?SIDE_INVALID:aDirection.ordinal());
		}
		
		public static byte side(int aSide) {
			return aSide > 5 || aSide < 0 ? SIDE_INVALID : (byte)aSide;
		}
		
		/** If this Index exists inside the passed Array and if it is != null */
		public static <E> boolean exists(int aIndex, E[] aArray) {
			return aIndex >= 0 && aIndex < aArray.length && aArray[aIndex] != null;
		}
		
		/** @return a Value for a Scale between 0 and aMax with aScale+1 possible Steps. 0 is only returned if the aValue is <= 0, aScale is only returned if the Value is >= aMax. The remaining values between ]0:aScale[ are returned for each Step of the Scale. This Function finds use in Displays such as the Barometer, but also in Redstone. */
		public static long scale(long aValue, long aMax, long aScale, boolean aInvert) {
			long rScale = (aValue <= 0 ? 0 : aValue >= aMax ? aScale : aScale <= 2 ? 1 : 1 + (aValue * (aScale-1)) / aMax);
			return aInvert ? aScale - rScale : rScale;
		}
		
		/** @return a Value for a Scale between aMin and aMax with aScale+1 possible Steps. 0 is only returned if the aValue is <= aMin, aScale is only returned if the Value is >= aMax. The remaining values between ]0:aScale[ are returned for each Step of the Scale. This Function finds use in Displays such as the Barometer, but also in Redstone. */
		public static long scale(long aValue, long aMin, long aMax, long aScale, boolean aInvert) {
			return scale(aValue-aMin, aMax-aMin, aScale, aInvert);
		}
		
		public static long bind(long aMin, long aMax, long aBoundValue) {
			return aMin > aMax ? Math.max(aMax, Math.min(aMin, aBoundValue)) : Math.max(aMin, Math.min(aMax, aBoundValue));
		}
		public static long bind_(long aMin, long aMax, long aBoundValue) {
			return Math.max(aMin, Math.min(aMax, aBoundValue));
		}
		
		public static byte  bind1 (long aBoundValue) {return (byte) Math.max(0, Math.min(         1, aBoundValue));}
		public static byte  bind2 (long aBoundValue) {return (byte) Math.max(0, Math.min(         3, aBoundValue));}
		public static byte  bind3 (long aBoundValue) {return (byte) Math.max(0, Math.min(         7, aBoundValue));}
		public static byte  bind4 (long aBoundValue) {return (byte) Math.max(0, Math.min(        15, aBoundValue));}
		public static byte  bind5 (long aBoundValue) {return (byte) Math.max(0, Math.min(        31, aBoundValue));}
		public static byte  bind6 (long aBoundValue) {return (byte) Math.max(0, Math.min(        63, aBoundValue));}
		public static byte  bind7 (long aBoundValue) {return (byte) Math.max(0, Math.min(       127, aBoundValue));}
		public static short bind8 (long aBoundValue) {return (short)Math.max(0, Math.min(       255, aBoundValue));}
		public static short bind15(long aBoundValue) {return (short)Math.max(0, Math.min(     32767, aBoundValue));}
		public static int   bind16(long aBoundValue) {return (int)  Math.max(0, Math.min(     65535, aBoundValue));}
		public static int   bind31(long aBoundValue) {return (int)  Math.max(0, Math.min(2147483647, aBoundValue));}
		
		public static byte bindStack(long aBoundValue) {
			return (byte)Math.max(1, Math.min(64, aBoundValue));
		}
		
		public static int bindInt(long aBoundValue) {
			return (int)Math.max(Integer.MIN_VALUE, Math.min(Integer.MAX_VALUE, aBoundValue));
		}
		
		public static short[] bindRGBa(short[] aColors) {
			if (aColors == null) return new short[] {255,255,255,255};
			for (int i = 0; i < aColors.length; i++) aColors[i] = bind8(aColors[i]);
			return aColors;
		}
		
		public static int mixRGBInt(int aRGB1, int aRGB2) {
			return getRGBInt(new short[] {(short)((getR(aRGB1) + getR(aRGB2)) >> 1), (short)((getG(aRGB1) + getG(aRGB2)) >> 1), (short)((getB(aRGB1) + getB(aRGB2)) >> 1)});
		}
		
		public static int getRGBInt(short[] aColors) {
			return aColors == null ? 16777215 : (bind8(aColors[0]) << 16) | (bind8(aColors[1]) << 8) | bind8(aColors[2]);
		}
		
		public static int getRGBaInt(short[] aColors) {
			return aColors == null ? 16777215 : (bind8(aColors[0]) << 16) | (bind8(aColors[1]) << 8) | bind8(aColors[2]) | (bind8(aColors[3]) << 24);
		}
		
		public static int getRGBInt(long aR, long aG, long aB) {
			return (bind8(aR) << 16) | (bind8(aG) << 8) | bind8(aB);
		}
		
		public static int getRGBaInt(long aR, long aG, long aB, long aA) {
			return (bind8(aR) << 16) | (bind8(aG) << 8) | bind8(aB) | (bind8(aA) << 24);
		}
		
		public static short[] getRGBaArray(int aColors) {
			return new short[] {(short)((aColors >> 16) & 255), (short)((aColors >> 8) & 255), (short)(aColors & 255), (short)((aColors >> 24) & 255)};
		}
		
		public static short getR(int aColors) {return (short)((aColors >> 16) & 255);}
		public static short getG(int aColors) {return (short)((aColors >> 8) & 255);}
		public static short getB(int aColors) {return (short)(aColors & 255);}
		public static short getA(int aColors) {return (short)((aColors >> 24) & 255);}
		
		@SideOnly(Side.CLIENT)
		@SuppressWarnings("cast")
		/** estebes helped with the code for this one */
		public static short[] color(ItemStack aStack) {
			if (Stacks.invalid(aStack)) return UNCOLOURED;
			IIcon tIcon = aStack.getIconIndex();
			if (tIcon == null) return UNCOLOURED;
			String tResourceLocation = tIcon.getIconName();
			if (stringInvalid(tResourceLocation)) return UNCOLOURED;
			short[] rColor = color(tResourceLocation);
			if (rColor == null) return UNCOLOURED;
			short[] rModulation = getRGBaArray(aStack.getItem().getColorFromItemStack(aStack, 0));
			for (byte i = 0; i < 3; i++) rColor[i] = (short)((rColor[i] * (int)rModulation[i]) / 255);
			return rColor;
		}
		
		@SideOnly(Side.CLIENT)
		/** estebes helped with the code for this one */
		public static short[] color(String aResourceLocation) {
	        ResourceLocation aux = null;
	        if (aResourceLocation.contains(":")) {
	            String[] modid_itemid = aResourceLocation.split(":");
	            aux = new ResourceLocation(modid_itemid[0], "textures/items/" + modid_itemid[1] + ".png");
	        } else {
	        	aux = new ResourceLocation("minecraft", "textures/items/" + aResourceLocation + ".png");
	        }
	        java.awt.image.BufferedImage tIcon = null;
	        try {tIcon = javax.imageio.ImageIO.read(Minecraft.getMinecraft().getResourceManager().getResource(aux).getInputStream());} catch (IOException e) {/**/}
	        return tIcon == null ? null : color(tIcon);
	    }
		
		@SideOnly(Side.CLIENT)
		/** estebes helped with the code for this one */
	    public static short[] color(java.awt.image.BufferedImage icon) {
	        long tR = 0, tG = 0, tB = 0, tPixels = 0;
	        for (int tWidth = 0; tWidth < icon.getWidth(); tWidth++) for (int tHeight = 0; tHeight < icon.getHeight(); tHeight++) {
	            int tPixel = icon.getRGB(tWidth, tHeight);
	            if (((tPixel >> 24) & 255) > 128) {
	                tR += (tPixel >> 16) & 255;
	                tG += (tPixel >> 8) & 255;
	                tB += tPixel & 255;
	                tPixels++;
	            }
	        }
	        return new short[] {(short)(tR / tPixels), (short)(tG / tPixels), (short)(tB / tPixels)};
	    }
		
		/** toUpperCases the first Character of the String and returns it */
		public static String capitalise(String aString) {
			if (aString != null && !aString.isEmpty()) return aString.substring(0, 1).toUpperCase() + aString.substring(1);
			return "";
		}
		
		/** @return the opposite facing of this Side of a Block, with a boundary check. */
		public static byte opposite(int aSide) {
			return aSide < OPPOSITES.length && aSide >= 0 ? OPPOSITES[aSide] : 6;
		}
		
	    /** Translates Amount of aUnit1 to Amount of aUnit2. */
	    public static long units(long aAmount, long aOriginalUnit, long aTargetUnit, boolean aRoundUp) {
	    	if (aOriginalUnit == aTargetUnit || aOriginalUnit == 0) return aAmount;
	    	return Math.max(0, ((aAmount * aTargetUnit) / aOriginalUnit) + (aRoundUp && (aAmount * aTargetUnit) % aOriginalUnit > 0 ? 1 : 0));
	    }
	    
	    /** Divides but rounds up. */
	    public static long divup(long aNumber, long aDivider) {
	    	return aNumber / aDivider + (aNumber % aDivider == 0 ? 0 : 1);
	    }
	    
	    public static boolean abs_greater(long aAmount1, long aAmount2) {return Math.abs(aAmount1) > Math.abs(aAmount2);}
	    public static boolean abs_smaller(long aAmount1, long aAmount2) {return Math.abs(aAmount1) < Math.abs(aAmount2);}
	    public static boolean abs_greater_equal(long aAmount1, long aAmount2) {return Math.abs(aAmount1) >= Math.abs(aAmount2);}
	    public static boolean abs_smaller_equal(long aAmount1, long aAmount2) {return Math.abs(aAmount1) <= Math.abs(aAmount2);}
	    
		/** @return an Array containing the X and the Y Coordinate of the clicked Point, with the top left Corner as Origin, like on the Texture Sheet. return values should always be between [0.0F and 0.99F]. */
		public static float[] getFacingCoordsClicked(byte aSide, float aHitX, float aHitY, float aHitZ) {
			switch (aSide) {
			case  0: return new float[] {Math.min(0.99F, Math.max(0,1-aHitX)), Math.min(0.99F, Math.max(0,  aHitZ))};
			case  1: return new float[] {Math.min(0.99F, Math.max(0,  aHitX)), Math.min(0.99F, Math.max(0,  aHitZ))};
			case  2: return new float[] {Math.min(0.99F, Math.max(0,1-aHitX)), Math.min(0.99F, Math.max(0,1-aHitY))};
			case  3: return new float[] {Math.min(0.99F, Math.max(0,  aHitX)), Math.min(0.99F, Math.max(0,1-aHitY))};
			case  4: return new float[] {Math.min(0.99F, Math.max(0,  aHitZ)), Math.min(0.99F, Math.max(0,1-aHitY))};
			case  5: return new float[] {Math.min(0.99F, Math.max(0,1-aHitZ)), Math.min(0.99F, Math.max(0,1-aHitY))};
			default: return new float[] {0.5F, 0.5F};
			}
		}
		
		public static byte getSideForPlayerPlacing(Entity aPlayer) {
			if (aPlayer.rotationPitch >=  65) return SIDE_UP;
			if (aPlayer.rotationPitch <= -65) return SIDE_DOWN;
			return COMPASS_DIRECTIONS[MathHelper.floor_double(4*aPlayer.rotationYaw/360+0.5)&3];
		}
		
		public static byte getSideForPlayerPlacing(Entity aPlayer, byte aDefaultFacing, boolean[] aAllowedFacings) {
			if (aPlayer.rotationPitch >=  65 && aAllowedFacings[SIDE_UP]) return SIDE_UP;
			if (aPlayer.rotationPitch <= -65 && aAllowedFacings[SIDE_DOWN]) return SIDE_DOWN;
			byte rFacing = COMPASS_DIRECTIONS[MathHelper.floor_double(0.5+4*aPlayer.rotationYaw/360)&3];
			if (aAllowedFacings[rFacing]) return rFacing;
			for (byte tSide : ALL_SIDES_VALID) if (aAllowedFacings[tSide]) return tSide;
			return aDefaultFacing;
		}
		
		public static byte getOppositeSideForPlayerPlacing(Entity aPlayer, byte aDefaultFacing, boolean[] aAllowedFacings) {
			if (aPlayer.rotationPitch >=  65 && aAllowedFacings[SIDE_DOWN]) return SIDE_DOWN;
			if (aPlayer.rotationPitch <= -65 && aAllowedFacings[SIDE_UP]) return SIDE_UP;
			byte rFacing = OPPOSITES[COMPASS_DIRECTIONS[MathHelper.floor_double(0.5+4*aPlayer.rotationYaw/360)&3]];
			if (aAllowedFacings[rFacing]) return rFacing;
			for (byte tSide : ALL_SIDES_VALID) if (aAllowedFacings[tSide]) return tSide;
			return aDefaultFacing;
		}
		
		/**
		 * This Function determines the direction a Block gets when being Wrenched.
		 * returns -1 if invalid. Even though that could never happen.
		 */
		public static byte getSideWrenching(byte aSide, float aHitX, float aHitY, float aHitZ) {
			switch (aSide) {
			case  0: case  1:
				if (aHitX < 0.25) return aHitZ < 0.25 || aHitZ > 0.75 ? OPPOSITES[aSide] : 4;
				if (aHitX > 0.75) return aHitZ < 0.25 || aHitZ > 0.75 ? OPPOSITES[aSide] : 5;
				if (aHitZ < 0.25) return 2;
				if (aHitZ > 0.75) return 3;
				return aSide;
			case  2: case  3:
				if (aHitX < 0.25) return aHitY < 0.25 || aHitY > 0.75 ? OPPOSITES[aSide] : 4;
				if (aHitX > 0.75) return aHitY < 0.25 || aHitY > 0.75 ? OPPOSITES[aSide] : 5;
				if (aHitY < 0.25) return 0;
				if (aHitY > 0.75) return 1;
				return aSide;
			case  4: case  5:
				if (aHitZ < 0.25) return aHitY < 0.25 || aHitY > 0.75 ? OPPOSITES[aSide] : 2;
				if (aHitZ > 0.75) return aHitY < 0.25 || aHitY > 0.75 ? OPPOSITES[aSide] : 3;
				if (aHitY < 0.25) return 0;
				if (aHitY > 0.75) return 1;
				return aSide;
			}
			return -1;
		}
	}
	
	public static class NBT {
		/** Turns each Object -> Object Pair into a Part of the passed NBT as Object-toString()-Key -> Value Pair */
		public static NBTTagCompound getNBTs(NBTTagCompound aNBT, Object... aTags) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
			for (int i = 1; i < aTags.length; i+=2) {
				if (aTags[i] == null) {/* Nothing */}
				else if (aTags[i] instanceof Boolean)			aNBT.setBoolean(	aTags[i-1].toString(), (Boolean)			aTags[i]);
			    else if (aTags[i] instanceof Byte)				aNBT.setByte(		aTags[i-1].toString(), (Byte)				aTags[i]);
				else if (aTags[i] instanceof Short)				aNBT.setShort(		aTags[i-1].toString(), (Short)				aTags[i]);
				else if (aTags[i] instanceof Integer)			aNBT.setInteger(	aTags[i-1].toString(), (Integer)			aTags[i]);
				else if (aTags[i] instanceof Long)				aNBT.setLong(		aTags[i-1].toString(), (Long)				aTags[i]);
				else if (aTags[i] instanceof Float)				aNBT.setFloat(		aTags[i-1].toString(), (Float)				aTags[i]);
				else if (aTags[i] instanceof Double)			aNBT.setDouble(		aTags[i-1].toString(), (Double)				aTags[i]);
				else if (aTags[i] instanceof String)			aNBT.setString(		aTags[i-1].toString(), (String)				aTags[i]);
				else if (aTags[i] instanceof NBTBase)			aNBT.setTag(		aTags[i-1].toString(), (NBTBase)			aTags[i]);
				else if (aTags[i] instanceof OreDictMaterial)	aNBT.setString(		aTags[i-1].toString(), ((OreDictMaterial)	aTags[i]).mNameInternal);
				else if (aTags[i] instanceof RecipeMap)			aNBT.setString(		aTags[i-1].toString(), ((RecipeMap)			aTags[i]).mNameInternal);
				else 											aNBT.setString(		aTags[i-1].toString(), aTags[i].toString());
			}
	    	return aNBT;
		}
		
		/** Fuses two NBT Compounds together with the Priority lying on the content of the first NBT */
		public static NBTTagCompound fuseNBTs(NBTTagCompound aNBT1, NBTTagCompound aNBT2) {
			if (aNBT1 == null) return aNBT2==null?new NBTTagCompound():(NBTTagCompound)aNBT2.copy();
			NBTTagCompound rNBT = (NBTTagCompound)aNBT1.copy();
			if (aNBT2 == null) return rNBT;
			for (Object tKey : aNBT2.func_150296_c()) if (!rNBT.hasKey(tKey.toString())) rNBT.setTag(tKey.toString(), aNBT2.getTag(tKey.toString()));
	    	return rNBT;
		}
		
	    public static NBTTagCompound getNBTBoolean(NBTTagCompound aNBT, Object aTag, boolean aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
	    	aNBT.setBoolean(aTag.toString(), aValue);
	    	return aNBT;
	    }
	    
	    public static NBTTagCompound getNBTByte(NBTTagCompound aNBT, Object aTag, byte aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
	    	aNBT.setByte(aTag.toString(), aValue);
	    	return aNBT;
	    }
	    
	    public static NBTTagCompound getNBTShort(NBTTagCompound aNBT, Object aTag, short aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
	    	aNBT.setShort(aTag.toString(), aValue);
	    	return aNBT;
	    }
	    
	    public static NBTTagCompound getNBTInteger(NBTTagCompound aNBT, Object aTag, int aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
	    	aNBT.setInteger(aTag.toString(), aValue);
	    	return aNBT;
	    }
	    
	    public static NBTTagCompound getNBTLong(NBTTagCompound aNBT, Object aTag, long aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
			NBT.setNumber(aNBT, aTag.toString(), aValue);
	    	return aNBT;
	    }
	    
	    public static NBTTagCompound getNBTFloat(NBTTagCompound aNBT, Object aTag, float aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
	    	aNBT.setFloat(aTag.toString(), aValue);
	    	return aNBT;
	    }
	    
	    public static NBTTagCompound getNBTDouble(NBTTagCompound aNBT, Object aTag, double aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
	    	aNBT.setDouble(aTag.toString(), aValue);
	    	return aNBT;
	    }
	    
	    public static NBTTagCompound getNBTString(NBTTagCompound aNBT, Object aTag, Object aValue) {
	    	if (aNBT == null) aNBT = new NBTTagCompound();
	    	if (aValue == null) return aNBT;
	    	aNBT.setString(aTag.toString(), aValue.toString());
	    	return aNBT;
	    }
	    
	    /** Saves on Data Size by simply not adding "false" Booleans. */
	    public static NBTTagCompound setBoolean(NBTTagCompound aNBT, Object aTag, boolean aValue) {
	    	if (aValue) {
	    		aNBT.setBoolean(aTag.toString(), aValue);
	    	} else {
	    		aNBT.removeTag(aTag.toString());
	    	}
	    	return aNBT;
	    }
	    
	    /** Saves on Data Size by choosing the smallest possible Data Type, and by also not adding zeros. The regular getLong() Function can also get the other Number Types. */
	    public static NBTTagCompound setNumber(NBTTagCompound aNBT, Object aTag, long aValue) {
	    	if (aValue == 0) {aNBT.removeTag(aTag.toString()); return aNBT;}
	    	if (aValue > Integer.MAX_VALUE || aValue < Integer.MIN_VALUE) {aNBT.setLong(aTag.toString(), aValue); return aNBT;}
	    	if (aValue > Short.MAX_VALUE || aValue < Short.MIN_VALUE) {aNBT.setInteger(aTag.toString(), (int)aValue); return aNBT;}
	    	if (aValue > Byte.MAX_VALUE || aValue < Byte.MIN_VALUE) {aNBT.setShort(aTag.toString(), (short)aValue); return aNBT;}
	    	aNBT.setByte(aTag.toString(), (byte)aValue);
	    	return aNBT;
	    }
	    
		public static void setNBT(ItemStack aStack, NBTTagCompound aNBT) {
			if (aNBT == null) {aStack.setTagCompound(null); return;}
			ArrayList<String> tTagsToRemove = new ArrayListNoNulls<String>();
			for (Object tKey : aNBT.func_150296_c()) {
				NBTBase tValue = aNBT.getTag((String)tKey);
				if (tValue == null || (tValue instanceof NBTPrimitive && ((NBTPrimitive)tValue).func_150291_c() == 0) || (tValue instanceof NBTTagString && Code.stringInvalid(((NBTTagString)tValue).func_150285_a_()))) tTagsToRemove.add((String)tKey);
			}
			for (Object tKey : tTagsToRemove) aNBT.removeTag((String)tKey);
			aStack.setTagCompound(aNBT.hasNoTags()?null:aNBT);
		}
		
		public static NBTTagCompound getNBT(ItemStack aStack) {
	    	NBTTagCompound rNBT = aStack.getTagCompound();
			return rNBT==null?new NBTTagCompound():rNBT;
		}
		
	    public static NBTTagCompound setPunchCardData(ItemStack aStack, String aPunchCardData) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	tNBT.setString("gt.punchcard", aPunchCardData);
	    	setNBT(aStack, tNBT);
	    	return tNBT;
	    }
	    public static String getPunchCardData(ItemStack aStack) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	return tNBT.getString("gt.punchcard");
	    }
	    public static NBTTagCompound setPunchCardData(NBTTagCompound aNBT, String aPunchCardData) {
	    	aNBT.setString("gt.punchcard", aPunchCardData);
	    	return aNBT;
	    }
	    public static String getPunchCardData(NBTTagCompound aNBT) {
	    	return aNBT.getString("gt.punchcard");
	    }
	    
	    public static NBTTagCompound setBlueprintCrafting(ItemStack aStack, ItemStack... aBlueprint) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	setBlueprintCrafting(tNBT, aBlueprint);
	    	setNBT(aStack, tNBT);
	    	return tNBT;
	    }
	    public static ItemStack[] getBlueprintCrafting(ItemStack aStack) {
	    	return getBlueprintCrafting(getNBT(aStack));
	    }
	    public static NBTTagCompound setBlueprintCrafting(NBTTagCompound aNBT, ItemStack... aBlueprint) {
	    	NBTTagCompound tList = new NBTTagCompound();
	    	boolean temp = F;
	        for (int i = 0; i < aBlueprint.length; i++) if (UT.Stacks.valid(aBlueprint[i])) {
	        	UT.Stacks.save(tList, ""+i, aBlueprint[i]);
	        	temp = T;
	        }
	        if (temp) aNBT.setTag("gt.blueprint.craft", tList);
	    	return aNBT;
	    }
	    public static ItemStack[] getBlueprintCrafting(NBTTagCompound aNBT) {
	    	NBTTagCompound tList = aNBT.hasKey("gt.blueprint.craft")?aNBT.getCompoundTag("gt.blueprint.craft"):null;
	    	if (tList != null) {
		    	ItemStack[] rRecipe = new ItemStack[9];
	    		for (int i = 0; i < rRecipe.length; i++) rRecipe[i] = UT.Stacks.amount(1, UT.Stacks.load(tList, ""+i));
		    	return rRecipe;
	    	}
	    	return ZL_ITEMSTACK;
	    }
	    
	    public static NBTTagCompound setLighterFuel(ItemStack aStack, long aFuel) {
	    	NBTTagCompound tNBT = getNBT(aStack);
			NBT.setNumber(tNBT, "gt.lighter", aFuel);
	    	setNBT(aStack, tNBT);
	    	return tNBT;
	    }
	    public static long getLighterFuel(ItemStack aStack) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	return tNBT.getLong("gt.lighter");
	    }
	    public static NBTTagCompound setLighterFuel(NBTTagCompound aNBT, long aFuel) {
			NBT.setNumber(aNBT, "gt.lighter", aFuel);
	    	return aNBT;
	    }
	    public static long getLighterFuel(NBTTagCompound aNBT) {
	    	return aNBT.getLong("gt.lighter");
	    }
	    
	    public static NBTTagCompound setMapID(ItemStack aStack, short aMapID) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	tNBT.setShort("map_id", aMapID);
	    	setNBT(aStack, tNBT);
	    	return tNBT;
	    }
	    public static short getMapID(ItemStack aStack) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	if (!tNBT.hasKey("map_id")) return -1;
	    	return tNBT.getShort("map_id");
	    }
	    public static NBTTagCompound setMapID(NBTTagCompound aNBT, short aMapID) {
	    	aNBT.setShort("map_id", aMapID);
	    	return aNBT;
	    }
	    public static short getMapID(NBTTagCompound aNBT) {
	    	if (!aNBT.hasKey("map_id")) return -1;
	    	return aNBT.getShort("map_id");
	    }
	    
	    public static NBTTagCompound setBookMapping(ItemStack aStack, String aTitle) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	tNBT.setString("book", aTitle);
	    	setNBT(aStack, tNBT);
	    	return tNBT;
	    }
	    public static String getBookMapping(ItemStack aStack) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	return tNBT.getString("book");
	    }
	    public static NBTTagCompound setBookMapping(NBTTagCompound aNBT, String aTitle) {
	    	aNBT.setString("book", aTitle);
	    	return aNBT;
	    }
	    public static String getBookMapping(NBTTagCompound aNBT) {
	    	return aNBT.getString("book");
	    }
	    
	    public static NBTTagCompound setBookTitle(ItemStack aStack, String aTitle) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	tNBT.setString("title", aTitle);
	    	setNBT(aStack, tNBT);
	    	return tNBT;
	    }
	    public static String getBookTitle(ItemStack aStack) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	return tNBT.getString("title");
	    }
	    public static NBTTagCompound setBookTitle(NBTTagCompound aNBT, String aTitle) {
	    	aNBT.setString("title", aTitle);
	    	return aNBT;
	    }
	    public static String getBookTitle(NBTTagCompound aNBT) {
	    	return aNBT.getString("title");
	    }
	    
		public static NBTTagCompound setBookAuthor(ItemStack aStack, String aAuthor) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	tNBT.setString("author", aAuthor);
	    	setNBT(aStack, tNBT);
	    	return tNBT;
	    }
		public static String getBookAuthor(ItemStack aStack) {
	    	NBTTagCompound tNBT = getNBT(aStack);
	    	return tNBT.getString("author");
	    }
		public static NBTTagCompound setBookAuthor(NBTTagCompound aNBT, String aAuthor) {
	    	aNBT.setString("author", aAuthor);
	    	return aNBT;
	    }
		public static String getBookAuthor(NBTTagCompound aNBT) {
	    	return aNBT.getString("author");
	    }
		
		public static List<String> getDataToolTip(NBTTagCompound aData, List<String> aList, boolean aAllDetails) {
			if (aData.hasKey(NBT_REACTOR_SETUP)) {
				aList.add(LH.Chat.CYAN + "Reactor Setup: " + aData.getString(NBT_REACTOR_SETUP_NAME));
				return aList;
			}
			if (aData.hasKey(NBT_CANVAS_BLOCK)) {
				aList.add(LH.Chat.CYAN + "Block Image: " + UT.Stacks.names(UT.Stacks.make(Block.getBlockById(aData.getInteger(NBT_CANVAS_BLOCK)), 1, aData.getInteger(NBT_CANVAS_META))));
				return aList;
			}
			if (aData.hasKey(NBT_REPLICATOR_DATA)) {
				short tIndex = aData.getShort(NBT_REPLICATOR_DATA);
				if (UT.Code.exists(tIndex, OreDictMaterial.MATERIAL_ARRAY)) {
					OreDictMaterial tMaterial = OreDictMaterial.MATERIAL_ARRAY[tIndex];
					if (tMaterial.contains(TD.Processing.UUM)) {
						if (aAllDetails) {
							aList.add(LH.Chat.CYAN + "Material Data: " + LH.Chat.WHITE + tMaterial.getLocal());
							aList.add(LH.Chat.CYAN + "Can be Replicated using");
							if (tMaterial.contains(TD.Atomic.ANTIMATTER)) {
								aList.add(LH.Chat.WHITE + "Neutral Antimatter: " + LH.Chat.YELLOW + tMaterial.mNeutrons);
								aList.add(LH.Chat.WHITE + "Charged Antimatter: " + LH.Chat.RED + tMaterial.mProtons);
							} else {
								aList.add(LH.Chat.WHITE + "Neutral Matter: " + LH.Chat.YELLOW + tMaterial.mNeutrons);
								aList.add(LH.Chat.WHITE + "Charged Matter: " + LH.Chat.RED + tMaterial.mProtons);
							}
							aList.add(LH.Chat.WHITE + "Energy: " + TD.Energy.QU.getChatFormat() + ((tMaterial.mNeutrons+tMaterial.mProtons)*65536) + " " + TD.Energy.QU.getLocalisedNameShort());
						} else {
							aList.add(LH.Chat.CYAN + "Mat Data: " + LH.Chat.WHITE + tMaterial.getLocal() + (aAllDetails ? "" : " ("+LH.Chat.YELLOW+tMaterial.mNeutrons+LH.Chat.WHITE+"/"+LH.Chat.RED+tMaterial.mProtons+LH.Chat.WHITE+"/"+TD.Energy.QU.getChatFormat()+((tMaterial.mNeutrons+tMaterial.mProtons)*65536)+LH.Chat.WHITE+")"));
						}
					} else {
						aList.add(LH.Chat.CYAN + "Material Data: " + LH.Chat.WHITE + tMaterial.getLocal() + LH.Chat.ORANGE + " (Not Replicatable)");
					}
				}
				return aList;
			}
			String tString = UT.NBT.getBookTitle(aData);
			if (UT.Code.stringValid(tString)) {
				aList.add(LH.Chat.CYAN + "Book: " + tString);
				if (aAllDetails) {
					tString = UT.NBT.getBookAuthor(aData);
					if (UT.Code.stringValid(tString)) aList.add(LH.Chat.CYAN + "by " + tString);
				}
				return aList;
			}
			short tMapID = UT.NBT.getMapID(aData);
			if (tMapID >= 0) {
				aList.add(LH.Chat.CYAN + "Map ID: " + tMapID);
				return aList;
			}
			tString = UT.NBT.getPunchCardData(aData);
			if (UT.Code.stringValid(tString)) {
				aList.add(LH.Chat.CYAN + "Punch Card Data");
				if (aAllDetails) for (int i = 0, j = tString.length(); i < j; i += 64) aList.add(LH.Chat.GREEN + tString.substring(i, Math.min(i+64, j)));
				return aList;
			}
			ItemStack[] tBlueprint = UT.NBT.getBlueprintCrafting(aData);
			if (tBlueprint != ZL_ITEMSTACK) {
				ItemStack tCrafted = GT_ModHandler.getAllRecipeOutput(null, tBlueprint);
				if (tCrafted == null) {
					aList.add(LH.Chat.CYAN + "Blueprint with random Items");
				} else {
					if (aAllDetails) {
						aList.add(LH.Chat.CYAN + "Blueprint for " + tCrafted.getDisplayName());
					} else {
						aList.add(LH.Chat.CYAN + "Blueprint: " + tCrafted.getDisplayName());
					}
				}
				return aList;
			}
			return aList;
		}
		
		public static void addEnchantment(ItemStack aStack, Enchantment aEnchantment, long aLevel) {
			NBTTagCompound tNBT = getNBT(aStack), tEnchantmentTag;
	        if (!tNBT.hasKey("ench", 9)) tNBT.setTag("ench", new NBTTagList());
	        NBTTagList tList = tNBT.getTagList("ench", 10);
	        
	        boolean temp = CS.T;
	        
	        for (int i = 0; i < tList.tagCount(); i++) {
	        	tEnchantmentTag = tList.getCompoundTagAt(i);
	        	if (tEnchantmentTag.getShort("id") == aEnchantment.effectId) {
	    	        tEnchantmentTag.setShort("id", (short)aEnchantment.effectId);
	    	        tEnchantmentTag.setShort("lvl", (byte)aLevel);
	    	        temp = F;
	    	        break;
	        	}
	        }
	        
	        if (temp) {
		        tEnchantmentTag = new NBTTagCompound();
		        tEnchantmentTag.setShort("id", (short)aEnchantment.effectId);
		        tEnchantmentTag.setShort("lvl", (byte)aLevel);
		        tList.appendTag(tEnchantmentTag);
	        }
	        aStack.setTagCompound(tNBT);
		}
	}
	
	/**
	 * THIS IS BULLSHIT!!! WHY DO I HAVE TO DO THIS SHIT JUST TO HAVE ENCHANTS PROPERLY!?!
	 */
	public static class Enchantments {
	    private static final BullshitIteratorA mBullshitIteratorA = new BullshitIteratorA();
	    private static final BullshitIteratorB mBullshitIteratorB = new BullshitIteratorB();
	    
	    private static void applyBullshit(IBullshit aBullshitModifier, ItemStack aStack) {
	        if (aStack != null) {
	            NBTTagList nbttaglist = aStack.getEnchantmentTagList();
	            if (nbttaglist != null) {
	                for (int i = 0; i < nbttaglist.tagCount(); ++i) {
	    	        	try {
	    	        	    short short1 = nbttaglist.getCompoundTagAt(i).getShort("id");
		                    short short2 = nbttaglist.getCompoundTagAt(i).getShort("lvl");
		                    if (Enchantment.enchantmentsList[short1] != null) aBullshitModifier.calculateModifier(Enchantment.enchantmentsList[short1], short2);
	    	        	} catch(Throwable e) {
	    	        		//
	    	        	}
	                }
	            }
	        }
	    }
	    
	    private static void applyArrayOfBullshit(IBullshit aBullshitModifier, ItemStack[] aStacks) {
	        for (int i = 0; i < aStacks.length; i++) applyBullshit(aBullshitModifier, aStacks[i]);
	    }
	    
	    public static void applyBullshitA(EntityLivingBase aPlayer, Entity aEntity, ItemStack aStack) {
	        mBullshitIteratorA.mPlayer = aPlayer;
	        mBullshitIteratorA.mEntity = aEntity;
	        if (aPlayer != null) applyArrayOfBullshit(mBullshitIteratorA, aPlayer.getLastActiveItems());
	        if (aStack != null) applyBullshit(mBullshitIteratorA, aStack);
	    }
	    
	    public static void applyBullshitB(EntityLivingBase aPlayer, Entity aEntity, ItemStack aStack) {
	        mBullshitIteratorB.mPlayer = aPlayer;
	        mBullshitIteratorB.mEntity = aEntity;
	        if (aPlayer != null) applyArrayOfBullshit(mBullshitIteratorB, aPlayer.getLastActiveItems());
	        if (aStack != null) applyBullshit(mBullshitIteratorB, aStack);
	    }
	    
	    static final class BullshitIteratorA implements IBullshit {
	        public EntityLivingBase mPlayer;
	        public Entity mEntity;
	        BullshitIteratorA() {}
	        
	        @Override
			public void calculateModifier(Enchantment aEnchantment, int aLevel) {
	            aEnchantment.func_151367_b(mPlayer, mEntity, aLevel);
	        }
	    }
	    
	    static final class BullshitIteratorB implements IBullshit {
	        public EntityLivingBase mPlayer;
	        public Entity mEntity;
	        BullshitIteratorB() {}
	        
	        @Override
			public void calculateModifier(Enchantment aEnchantment, int aLevel) {
	            aEnchantment.func_151368_a(mPlayer, mEntity, aLevel);
	        }
	    }
	    
	    interface IBullshit {
	        void calculateModifier(Enchantment aEnchantment, int aLevel);
	    }
	}
	
	public static class Reflection {
		public static Field getPublicField(Object aObject, String aField) {
			Field rField = null;
			try {
				rField = aObject.getClass().getDeclaredField(aField);
			} catch (Throwable e) {/*Do nothing*/}
			return rField;
		}
		
		public static Field getField(Object aObject, String aField) {
			Field rField = null;
			try {
				rField = aObject.getClass().getDeclaredField(aField);
				rField.setAccessible(T);
			} catch (Throwable e) {/*Do nothing*/}
			return rField;
		}
		
		public static Field getField(Class aObject, String aField) {
			Field rField = null;
			try {
				rField = aObject.getDeclaredField(aField);
				rField.setAccessible(T);
			} catch (Throwable e) {/*Do nothing*/}
			return rField;
		}
		
		public static Method getMethod(Class aObject, String aMethod, Class<?>... aParameterTypes) {
			Method rMethod = null;
			try {
				rMethod = aObject.getMethod(aMethod, aParameterTypes);
				rMethod.setAccessible(T);
			} catch (Throwable e) {/*Do nothing*/}
			return rMethod;
		}

		public static Method getMethod(Object aObject, String aMethod, Class<?>... aParameterTypes) {
			Method rMethod = null;
			try {
				rMethod = aObject.getClass().getMethod(aMethod, aParameterTypes);
				rMethod.setAccessible(T);
			} catch (Throwable e) {/*Do nothing*/}
			return rMethod;
		}

		public static Field getField(Object aObject, String aField, boolean aPrivate, boolean aLogErrors) {
			try {
				Field tField = (aObject instanceof Class)?((Class)aObject).getDeclaredField(aField):(aObject instanceof String)?Class.forName((String)aObject).getDeclaredField(aField):aObject.getClass().getDeclaredField(aField);
				if (aPrivate) tField.setAccessible(T);
				return tField;
			} catch (Throwable e) {
				if (aLogErrors) e.printStackTrace(ERR);
			}
			return null;
		}
		
		public static Object getFieldContent(Object aObject, String aField, boolean aPrivate, boolean aLogErrors) {
			try {
				Field tField = (aObject instanceof Class)?((Class)aObject).getDeclaredField(aField):(aObject instanceof String)?Class.forName((String)aObject).getDeclaredField(aField):aObject.getClass().getDeclaredField(aField);
				if (aPrivate) tField.setAccessible(T);
				return tField.get(aObject instanceof Class || aObject instanceof String ? null : aObject);
			} catch (Throwable e) {
				if (aLogErrors) e.printStackTrace(ERR);
			}
			return null;
		}
		
		public static Object callPublicMethod(Object aObject, String aMethod, Object... aParameters) {
			return callMethod(aObject, aMethod, F, F, T, aParameters);
		}

		public static Object callPrivateMethod(Object aObject, String aMethod, Object... aParameters) {
			return callMethod(aObject, aMethod, T, F, T, aParameters);
		}
		
		public static Object callMethod(Object aObject, String aMethod, boolean aPrivate, boolean aUseUpperCasedDataTypes, boolean aLogErrors, Object... aParameters) {
			try {
				Class<?>[] tParameterTypes = new Class<?>[aParameters.length];
				for (byte i = 0; i < aParameters.length; i++) {
					if (aParameters[i] instanceof Class) {
						tParameterTypes[i] = (Class)aParameters[i];
						aParameters[i] = null;
					} else {
						tParameterTypes[i] = aParameters[i].getClass();
					}
					if (!aUseUpperCasedDataTypes) {
						if (tParameterTypes[i] == Boolean.class	) tParameterTypes[i] = boolean.class;	else
						if (tParameterTypes[i] == Byte.class	) tParameterTypes[i] = byte.class;		else
						if (tParameterTypes[i] == Short.class	) tParameterTypes[i] = short.class;		else
						if (tParameterTypes[i] == Integer.class	) tParameterTypes[i] = int.class;		else
						if (tParameterTypes[i] == Long.class	) tParameterTypes[i] = long.class;		else
						if (tParameterTypes[i] == Float.class	) tParameterTypes[i] = float.class;		else
						if (tParameterTypes[i] == Double.class	) tParameterTypes[i] = double.class;
					}
				}
				
				Method tMethod = (aObject instanceof Class)?((Class)aObject).getMethod(aMethod, tParameterTypes):aObject.getClass().getMethod(aMethod, tParameterTypes);
				if (aPrivate) tMethod.setAccessible(T);
				return tMethod.invoke(aObject, aParameters);
			} catch (Throwable e) {
				if (aLogErrors) e.printStackTrace(ERR);
			}
			return null;
		}
		
		public static Object callConstructor(String aClass, int aConstructorIndex, Object aReplacementObject, boolean aLogErrors, Object... aParameters) {
			try {return callConstructor(Class.forName(aClass), aConstructorIndex, aReplacementObject, aLogErrors, aParameters);} catch (Throwable e) {if (aLogErrors) e.printStackTrace(ERR);} return aReplacementObject;
		}
		
		public static Object callConstructor(Class aClass, int aConstructorIndex, Object aReplacementObject, boolean aLogErrors, Object... aParameters) {
			if (aConstructorIndex < 0) {
				try {
					for (Constructor tConstructor : aClass.getConstructors()) {
						try {
							return tConstructor.newInstance(aParameters);
						} catch (Throwable e) {/*Do nothing*/}
					}
				} catch (Throwable e) {
					if (aLogErrors) e.printStackTrace(ERR);
				}
			} else {
				try {
					return aClass.getConstructors()[aConstructorIndex].newInstance(aParameters);
				} catch (Throwable e) {
					if (aLogErrors) e.printStackTrace(ERR);
				}
			}
			return aReplacementObject;
		}
		
	    public static String getClassName(Object aObject) {
	    	if (aObject == null) return "null";
	    	return aObject.getClass().getName().substring(aObject.getClass().getName().lastIndexOf(".")+1);
	    }
	}
	
	public static class Inventories {
		public static boolean TE_CHECK = F, BC_CHECK = F, CHECK_ALL = T;
		
		public static void checkAvailabilities() {
			if (CHECK_ALL) {
				try {
					Class tClass = cofh.api.transport.IItemConduit.class;
					tClass.getCanonicalName();
					TE_CHECK = T;
				} catch(Throwable e) {/**/}
				try {
					Class tClass = buildcraft.api.transport.IInjectable.class;
					tClass.getCanonicalName();
					BC_CHECK = T;
				} catch(Throwable e) {/**/}
				CHECK_ALL = F;
			}
		}
		
		public static boolean isConnectableNonInventoryPipe(Object aTileEntity, int aSide) {
			if (aTileEntity == null) return F;
			checkAvailabilities();
			if (TE_CHECK) if (aTileEntity instanceof cofh.api.transport.IItemConduit) return T;
			if (BC_CHECK) if (aTileEntity instanceof buildcraft.api.transport.IInjectable) return ((buildcraft.api.transport.IInjectable)aTileEntity).canInjectItems(FORGE_DIR[aSide]);
			return F;
		}
		
		/**
		 * Moves Stack from Inv-Slot to Pipe
		 * @return the Amount of moved Items
		 */
		public static byte moveStackIntoPipe(IInventory aTileEntity1, Object aTarget, int[] aGrabSlots, byte aGrabFrom, byte aPutTo, List<ItemStack> aFilter, boolean aInvertFilter, int aMaxTargetStackSize, int aMinTargetStackSize, int aMaxMoveAtOnce, int aMinMoveAtOnce) {
			if (aTileEntity1 == null || aMaxTargetStackSize <= 0 || aMinTargetStackSize <= 0 || aMinTargetStackSize > aMaxTargetStackSize || aMaxMoveAtOnce <= 0 || aMinMoveAtOnce > aMaxMoveAtOnce) return 0;
			
			Object aTileEntity2 = aTarget;
			if (aTarget instanceof DelegatorTileEntity) aTileEntity2 = ((DelegatorTileEntity)aTarget).mTileEntity;
			
			if (aTileEntity2 != null) {
				checkAvailabilities();
				if (TE_CHECK && aTileEntity2 instanceof cofh.api.transport.IItemConduit) {
					for (int i = 0; i < aGrabSlots.length; i++) {
						if (Stacks.inList(aFilter, aTileEntity1.getStackInSlot(aGrabSlots[i]), T, aInvertFilter)) {
							if (isAllowedToTakeFromSlot(aTileEntity1, aGrabSlots[i], aGrabFrom, aTileEntity1.getStackInSlot(aGrabSlots[i]))) {
								if (Math.max(aMinMoveAtOnce, aMinTargetStackSize) <= aTileEntity1.getStackInSlot(aGrabSlots[i]).stackSize) {
									ItemStack tStack = Stacks.amount(Math.min(aTileEntity1.getStackInSlot(aGrabSlots[i]).stackSize, Math.min(aMaxMoveAtOnce, aMaxTargetStackSize)), aTileEntity1.getStackInSlot(aGrabSlots[i]));
									ItemStack rStack = ((cofh.api.transport.IItemConduit)aTileEntity2).insertItem(FORGE_DIR[aPutTo], Stacks.copy(tStack), F/*T*/);
									byte tMovedItemCount = (byte)(tStack.stackSize - (rStack == null ? 0 : rStack.stackSize));
									if (tMovedItemCount >= 1/*Math.max(aMinMoveAtOnce, aMinTargetStackSize)*/) {
										//((cofh.api.transport.IItemConduit)aTileEntity2).insertItem(FORGE_DIR[aPutTo], copyAmount(tMovedItemCount, tStack), F);
										aTileEntity1.decrStackSize(aGrabSlots[i], tMovedItemCount);
										aTileEntity1.markDirty();
										return tMovedItemCount;
									}
								}
							}
						}
					}
					return 0;
				}
				if (BC_CHECK && aTileEntity2 instanceof buildcraft.api.transport.IInjectable) {
					for (int i = 0; i < aGrabSlots.length; i++) {
						if (Stacks.inList(aFilter, aTileEntity1.getStackInSlot(aGrabSlots[i]), T, aInvertFilter)) {
							if (isAllowedToTakeFromSlot(aTileEntity1, aGrabSlots[i], aGrabFrom, aTileEntity1.getStackInSlot(aGrabSlots[i]))) {
								if (Math.max(aMinMoveAtOnce, aMinTargetStackSize) <= aTileEntity1.getStackInSlot(aGrabSlots[i]).stackSize) {
									ItemStack tStack = Stacks.amount(Math.min(aTileEntity1.getStackInSlot(aGrabSlots[i]).stackSize, Math.min(aMaxMoveAtOnce, aMaxTargetStackSize)), aTileEntity1.getStackInSlot(aGrabSlots[i]));
									byte tMovedItemCount = (byte)((buildcraft.api.transport.IInjectable)aTileEntity2).injectItem(Stacks.copy(tStack), F, FORGE_DIR[aPutTo], null);
									if (tMovedItemCount >= Math.max(aMinMoveAtOnce, aMinTargetStackSize)) {
										tMovedItemCount = (byte)(((buildcraft.api.transport.IInjectable)aTileEntity2).injectItem(Stacks.amount(tMovedItemCount, tStack), T, FORGE_DIR[aPutTo], null));
										aTileEntity1.decrStackSize(aGrabSlots[i], tMovedItemCount);
										aTileEntity1.markDirty();
										return tMovedItemCount;
									}
								}
							}
						}
					}
					return 0;
				}
			}
			
			if (aTarget instanceof DelegatorTileEntity) {
				if (!Worlds.hasBlockHitBox(((DelegatorTileEntity)aTarget).mWorld, ((DelegatorTileEntity)aTarget).mX, ((DelegatorTileEntity)aTarget).mY, ((DelegatorTileEntity)aTarget).mZ)) {
					for (int i = 0; i < aGrabSlots.length; i++) {
						if (Stacks.inList(aFilter, aTileEntity1.getStackInSlot(aGrabSlots[i]), T, aInvertFilter)) {
							if (isAllowedToTakeFromSlot(aTileEntity1, aGrabSlots[i], aGrabFrom, aTileEntity1.getStackInSlot(aGrabSlots[i]))) {
								if (Math.max(aMinMoveAtOnce, aMinTargetStackSize) <= aTileEntity1.getStackInSlot(aGrabSlots[i]).stackSize) {
									ItemStack tStack = Stacks.amount(Math.min(aTileEntity1.getStackInSlot(aGrabSlots[i]).stackSize, Math.min(aMaxMoveAtOnce, aMaxTargetStackSize)), aTileEntity1.getStackInSlot(aGrabSlots[i]));
									EntityItem tEntity = new EntityItem(((DelegatorTileEntity)aTarget).mWorld, ((DelegatorTileEntity)aTarget).mX+0.5, ((DelegatorTileEntity)aTarget).mY+0.5, ((DelegatorTileEntity)aTarget).mZ+0.5, tStack);
									tEntity.motionX = tEntity.motionY = tEntity.motionZ = 0;
									((DelegatorTileEntity)aTarget).mWorld.spawnEntityInWorld(tEntity);
									aTileEntity1.decrStackSize(aGrabSlots[i], tStack.stackSize);
									aTileEntity1.markDirty();
									return (byte)tStack.stackSize;
								}
							}
						}
					}
				}
			}
			return 0;
		}
		
		/**
		 * Moves Stack from Inv-Slot to Inv-Slot, without checking if its even allowed. (useful for internal Inventory Operations)
		 * @return the Amount of moved Items
		 */
		public static byte moveStackFromSlotAToSlotB(IInventory aTileEntity1, IInventory aTileEntity2, int aGrabFrom, int aPutTo, int aMaxTargetStackSize, int aMinTargetStackSize, int aMaxMoveAtOnce, int aMinMoveAtOnce) {
			if (aTileEntity1 == null || aTileEntity2 == null || aMaxTargetStackSize <= 0 || aMinTargetStackSize <= 0 || aMinTargetStackSize > aMaxTargetStackSize || aMaxMoveAtOnce <= 0 || aMinMoveAtOnce > aMaxMoveAtOnce) return 0;
			
			ItemStack tStack1 = aTileEntity1.getStackInSlot(aGrabFrom), tStack2 = aTileEntity2.getStackInSlot(aPutTo), tStack3 = null;
			if (tStack1 != null) {
				if (tStack2 != null && !Stacks.equal(tStack1, tStack2)) return 0;
				tStack3 = Stacks.copy(tStack1);
				aMaxTargetStackSize = (byte)Math.min(aMaxTargetStackSize, Math.min(tStack3.getMaxStackSize(), Math.min(tStack2==null?Integer.MAX_VALUE:tStack2.getMaxStackSize(), aTileEntity2.getInventoryStackLimit())));
				tStack3.stackSize = Math.min(tStack3.stackSize, aMaxTargetStackSize - (tStack2 == null?0:tStack2.stackSize));
				if (tStack3.stackSize > aMaxMoveAtOnce) tStack3.stackSize = aMaxMoveAtOnce;
				if (tStack3.stackSize + (tStack2==null?0:tStack2.stackSize) >= Math.min(tStack3.getMaxStackSize(), aMinTargetStackSize) && tStack3.stackSize >= aMinMoveAtOnce) {
					tStack3 = aTileEntity1.decrStackSize(aGrabFrom, tStack3.stackSize);
					aTileEntity1.markDirty();
					if (tStack3 != null) {
						if (tStack2 == null) {
							aTileEntity2.setInventorySlotContents(aPutTo, Stacks.copy(tStack3));
							aTileEntity2.markDirty();
						} else {
							tStack2.stackSize += tStack3.stackSize;
							aTileEntity2.markDirty();
						}
						return (byte)tStack3.stackSize;
					}
				}
			}
			return 0;
		}
		
		public static boolean isAllowedToTakeFromSlot(IInventory aTileEntity, int aSlot, byte aSide, ItemStack aStack) {
			if (SIDES_INVALID[aSide]) {
				return isAllowedToTakeFromSlot(aTileEntity, aSlot, (byte)0, aStack)
					|| isAllowedToTakeFromSlot(aTileEntity, aSlot, (byte)1, aStack)
					|| isAllowedToTakeFromSlot(aTileEntity, aSlot, (byte)2, aStack)
					|| isAllowedToTakeFromSlot(aTileEntity, aSlot, (byte)3, aStack)
					|| isAllowedToTakeFromSlot(aTileEntity, aSlot, (byte)4, aStack)
					|| isAllowedToTakeFromSlot(aTileEntity, aSlot, (byte)5, aStack);
			}
			if (aTileEntity instanceof ISidedInventory) return ((ISidedInventory)aTileEntity).canExtractItem(aSlot, aStack, aSide);
			return T;
		}
		
		public static boolean isAllowedToPutIntoSlot(IInventory aTileEntity, int aSlot, byte aSide, ItemStack aStack, int aMaxStackSize) {
			ItemStack tStack = aTileEntity.getStackInSlot(aSlot);
			if (tStack != null && (!Stacks.equal(tStack, aStack) || tStack.stackSize >= tStack.getMaxStackSize())) return F;
			if (SIDES_INVALID[aSide]) {
				return isAllowedToPutIntoSlot(aTileEntity, aSlot, (byte)0, aStack, aMaxStackSize)
					|| isAllowedToPutIntoSlot(aTileEntity, aSlot, (byte)1, aStack, aMaxStackSize)
					|| isAllowedToPutIntoSlot(aTileEntity, aSlot, (byte)2, aStack, aMaxStackSize)
					|| isAllowedToPutIntoSlot(aTileEntity, aSlot, (byte)3, aStack, aMaxStackSize)
					|| isAllowedToPutIntoSlot(aTileEntity, aSlot, (byte)4, aStack, aMaxStackSize)
					|| isAllowedToPutIntoSlot(aTileEntity, aSlot, (byte)5, aStack, aMaxStackSize);
			}
			if (aTileEntity instanceof ISidedInventory && !((ISidedInventory)aTileEntity).canInsertItem(aSlot, aStack, aSide)) return F;
			return aTileEntity.isItemValidForSlot(aSlot, aStack);
		}
		
		/**
		 * Moves Stack from Inv-Side to Inv-Side.
		 * @return the Amount of moved Items
		 */
		public static byte moveOneItemStack(Object aTileEntity1, Object aTileEntity2, byte aGrabFrom, byte aPutTo, List<ItemStack> aFilter, boolean aInvertFilter, int aMaxTargetStackSize, int aMinTargetStackSize, int aMaxMoveAtOnce, int aMinMoveAtOnce) {
			if (aTileEntity1 instanceof IInventory) return moveOneItemStack((IInventory)aTileEntity1, aTileEntity2, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, T);
			return 0;
		}
		
		/**
		 * This is only because I needed an additional Parameter for the Double Chest Check.
		 */
		private static byte moveOneItemStack(IInventory aTileEntity1, Object aTarget, byte aGrabFrom, byte aPutTo, List<ItemStack> aFilter, boolean aInvertFilter, int aMaxTargetStackSize, int aMinTargetStackSize, int aMaxMoveAtOnce, int aMinMoveAtOnce, boolean aDoCheckChests) {
			if (aTileEntity1 == null || aMaxTargetStackSize <= 0 || aMinTargetStackSize <= 0 || aMaxMoveAtOnce <= 0 || aMinTargetStackSize > aMaxTargetStackSize || aMinMoveAtOnce > aMaxMoveAtOnce) return 0;
			
			Object aTileEntity2 = aTarget;
			if (aTarget instanceof DelegatorTileEntity) aTileEntity2 = ((DelegatorTileEntity)aTarget).mTileEntity;
			
			int[] tGrabSlots = null;
			if (aTileEntity1 instanceof ISidedInventory) tGrabSlots = ((ISidedInventory)aTileEntity1).getAccessibleSlotsFromSide(aGrabFrom);
			if (tGrabSlots == null) tGrabSlots = Code.getAscendingArray(aTileEntity1.getSizeInventory());
			
			if (aTileEntity2 instanceof IInventory) {
				int[] tPutSlots = null;
				if (aTileEntity2 instanceof ISidedInventory) tPutSlots = ((ISidedInventory)aTileEntity2).getAccessibleSlotsFromSide(aPutTo);
				
				if (tPutSlots == null) {
					tPutSlots = new int[((IInventory)aTileEntity2).getSizeInventory()];
					for (int i = 0; i < tPutSlots.length; i++) tPutSlots[i] = i;
				}
				
				for (int i = 0; i < tGrabSlots.length; i++) {
					for (int j = 0; j < tPutSlots.length; j++) {
						if (Stacks.inList(aFilter, aTileEntity1.getStackInSlot(tGrabSlots[i]), T, aInvertFilter)) {
							if (isAllowedToTakeFromSlot(aTileEntity1, tGrabSlots[i], aGrabFrom, aTileEntity1.getStackInSlot(tGrabSlots[i]))) {
								if (isAllowedToPutIntoSlot((IInventory)aTileEntity2, tPutSlots[j], aPutTo, aTileEntity1.getStackInSlot(tGrabSlots[i]), aMaxTargetStackSize)) {
									byte tMovedItemCount = moveStackFromSlotAToSlotB(aTileEntity1, (IInventory)aTileEntity2, tGrabSlots[i], tPutSlots[j], aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce);
									if (tMovedItemCount > 0) return tMovedItemCount;
								}
							}
						}
					}
				}
				
				if (aDoCheckChests) {
					if (aTileEntity1 instanceof TileEntityChest) {
						TileEntityChest tTileEntity1 = (TileEntityChest)aTileEntity1;
						if (tTileEntity1.adjacentChestChecked) {
							byte tAmount = 0;
							if (tTileEntity1.adjacentChestXNeg != null) {
								tAmount = moveOneItemStack(tTileEntity1.adjacentChestXNeg, aTileEntity2, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							} else if (tTileEntity1.adjacentChestZNeg != null) {
								tAmount = moveOneItemStack(tTileEntity1.adjacentChestZNeg, aTileEntity2, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							} else if (tTileEntity1.adjacentChestXPos != null) {
								tAmount = moveOneItemStack(tTileEntity1.adjacentChestXPos, aTileEntity2, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							} else if (tTileEntity1.adjacentChestZPos != null) {
								tAmount = moveOneItemStack(tTileEntity1.adjacentChestZPos, aTileEntity2, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							}
							if (tAmount != 0) return tAmount;
						}
					}
					if (aTileEntity2 instanceof TileEntityChest) {
						TileEntityChest tTileEntity2 = (TileEntityChest)aTileEntity2;
						if (tTileEntity2.adjacentChestChecked) {
							byte tAmount = 0;
							if (tTileEntity2.adjacentChestXNeg != null) {
								tAmount = moveOneItemStack(aTileEntity1, tTileEntity2.adjacentChestXNeg, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							} else if (tTileEntity2.adjacentChestZNeg != null) {
								tAmount = moveOneItemStack(aTileEntity1, tTileEntity2.adjacentChestZNeg, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							} else if (tTileEntity2.adjacentChestXPos != null) {
								tAmount = moveOneItemStack(aTileEntity1, tTileEntity2.adjacentChestXPos, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							} else if (tTileEntity2.adjacentChestZPos != null) {
								tAmount = moveOneItemStack(aTileEntity1, tTileEntity2.adjacentChestZPos, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce, F);
							}
							if (tAmount != 0) return tAmount;
						}
					}
				}
			}
			
			return moveStackIntoPipe(aTileEntity1, aTarget, tGrabSlots, aGrabFrom, aPutTo, aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce);
		}
		
		/**
		 * Moves Stack from Inv-Side to Inv-Slot.
		 * @return the Amount of moved Items
		 */
		public static byte moveOneItemStackIntoSlot(Object aTileEntity1, Object aTarget, byte aGrabFrom, int aPutTo, List<ItemStack> aFilter, boolean aInvertFilter, int aMaxTargetStackSize, int aMinTargetStackSize, int aMaxMoveAtOnce, int aMinMoveAtOnce) {
			if (aTileEntity1 == null || !(aTileEntity1 instanceof IInventory) || aPutTo < 0 || aMaxTargetStackSize <= 0 || aMinTargetStackSize <= 0 || aMaxMoveAtOnce <= 0 || aMinTargetStackSize > aMaxTargetStackSize || aMinMoveAtOnce > aMaxMoveAtOnce) return 0;
			
			Object aTileEntity2 = aTarget;
			if (aTarget instanceof DelegatorTileEntity) aTileEntity2 = ((DelegatorTileEntity)aTarget).mTileEntity;
			
			int[] tGrabSlots = null;
			if (aTileEntity1 instanceof ISidedInventory) tGrabSlots = ((ISidedInventory)aTileEntity1).getAccessibleSlotsFromSide(aGrabFrom);
			if (tGrabSlots == null) tGrabSlots = Code.getAscendingArray(((IInventory)aTileEntity1).getSizeInventory());
			
			if (aTileEntity2 != null && aTileEntity2 instanceof IInventory) {
				for (int i = 0; i < tGrabSlots.length; i++) {
					if (Stacks.inList(aFilter, ((IInventory)aTileEntity1).getStackInSlot(tGrabSlots[i]), T, aInvertFilter)) {
						if (isAllowedToTakeFromSlot((IInventory)aTileEntity1, tGrabSlots[i], aGrabFrom, ((IInventory)aTileEntity1).getStackInSlot(tGrabSlots[i]))) {
							if (isAllowedToPutIntoSlot((IInventory)aTileEntity2, aPutTo, SIDE_ANY, ((IInventory)aTileEntity1).getStackInSlot(tGrabSlots[i]), aMaxTargetStackSize)) {
								byte tMovedItemCount = moveStackFromSlotAToSlotB((IInventory)aTileEntity1, (IInventory)aTileEntity2, tGrabSlots[i], aPutTo, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce);
								if (tMovedItemCount > 0) return tMovedItemCount;
							}
						}
					}
				}
			}
			
			moveStackIntoPipe(((IInventory)aTileEntity1), aTarget, tGrabSlots, aGrabFrom, OPPOSITES[aGrabFrom], aFilter, aInvertFilter, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce);
			return 0;
		}
		
		/**
		 * Moves Stack from Inv-Slot to Inv-Slot.
		 * @return the Amount of moved Items
		 */
		public static byte moveFromSlotToSlot(IInventory aTileEntity1, IInventory aTileEntity2, int aGrabFrom, int aPutTo, List<ItemStack> aFilter, boolean aInvertFilter, int aMaxTargetStackSize, int aMinTargetStackSize, int aMaxMoveAtOnce, int aMinMoveAtOnce) {
			if (aTileEntity1 == null || aTileEntity2 == null || aGrabFrom < 0 || aPutTo < 0 || aMaxTargetStackSize <= 0 || aMinTargetStackSize <= 0 || aMaxMoveAtOnce <= 0 || aMinTargetStackSize > aMaxTargetStackSize || aMinMoveAtOnce > aMaxMoveAtOnce) return 0;
			if (Stacks.inList(aFilter, aTileEntity1.getStackInSlot(aGrabFrom), T, aInvertFilter)) {
				if (isAllowedToTakeFromSlot(aTileEntity1, aGrabFrom, SIDE_UNKNOWN, aTileEntity1.getStackInSlot(aGrabFrom))) {
					if (isAllowedToPutIntoSlot(aTileEntity2, aPutTo, SIDE_UNKNOWN, aTileEntity1.getStackInSlot(aGrabFrom), aMaxTargetStackSize)) {
						byte tMovedItemCount = moveStackFromSlotAToSlotB(aTileEntity1, aTileEntity2, aGrabFrom, aPutTo, aMaxTargetStackSize, aMinTargetStackSize, aMaxMoveAtOnce, aMinMoveAtOnce);
						if (tMovedItemCount > 0) return tMovedItemCount;
					}
				}
			}
			return 0;
		}
		
		public static void removeNullStacksFromInventory(IInventory aInventory) {
			if (aInventory != null) for (int i = 0, j = aInventory.getSizeInventory(); i < j; i++) {
				ItemStack tStack = aInventory.getStackInSlot(i);
				if (tStack != null && (tStack.stackSize == 0 || tStack.getItem() == null)) aInventory.setInventorySlotContents(i, null);
			}
		}
		
		public static boolean addStackToPlayerInventory(EntityPlayer aPlayer, ItemStack aStack) {
			return addStackToPlayerInventory(aPlayer, aStack, F);
		}
		
		public static boolean addStackToPlayerInventory(EntityPlayer aPlayer, ItemStack aStack, boolean aCurrentSlotFirst) {
			if (aPlayer != null && aStack != null) {
				for (int i = 0; i < 36; i++) if (i != aPlayer.inventory.currentItem) {
					ItemStack tStack = aPlayer.inventory.getStackInSlot(i);
					if (Stacks.equal(tStack, aStack) && aStack.stackSize + tStack.stackSize <= tStack.getMaxStackSize()) {
						tStack.stackSize += aStack.stackSize;
						if (aPlayer.openContainer != null) aPlayer.openContainer.detectAndSendChanges();
						return T;
					}
				}
				if (aCurrentSlotFirst) {
					ItemStack tStack = aPlayer.inventory.getStackInSlot(aPlayer.inventory.currentItem);
					if (tStack == null || tStack.stackSize == 0) {
						aPlayer.inventory.setInventorySlotContents(aPlayer.inventory.currentItem, aStack);
						if (aPlayer.openContainer != null) aPlayer.openContainer.detectAndSendChanges();
						return T;
					} else if (Stacks.equal(tStack, aStack) && aStack.stackSize + tStack.stackSize <= tStack.getMaxStackSize()) {
						tStack.stackSize += aStack.stackSize;
						if (aPlayer.openContainer != null) aPlayer.openContainer.detectAndSendChanges();
						return T;
					}
				}
				for (int i = 0; i < 36; i++) if (i != aPlayer.inventory.currentItem) {
					ItemStack tStack = aPlayer.inventory.getStackInSlot(i);
					if (tStack == null || tStack.stackSize <= 0) {
						aPlayer.inventory.setInventorySlotContents(i, aStack);
						if (aPlayer.openContainer != null) aPlayer.openContainer.detectAndSendChanges();
						return T;
					}
				}
				if (!aCurrentSlotFirst) {
					ItemStack tStack = aPlayer.inventory.getStackInSlot(aPlayer.inventory.currentItem);
					if (tStack == null || tStack.stackSize == 0) {
						aPlayer.inventory.setInventorySlotContents(aPlayer.inventory.currentItem, aStack);
						if (aPlayer.openContainer != null) aPlayer.openContainer.detectAndSendChanges();
						return T;
					} else if (Stacks.equal(tStack, aStack) && aStack.stackSize + tStack.stackSize <= tStack.getMaxStackSize()) {
						tStack.stackSize += aStack.stackSize;
						if (aPlayer.openContainer != null) aPlayer.openContainer.detectAndSendChanges();
						return T;
					}
				}
			}
			return F;
		}
		
		public static ItemStack getProjectile(TagData aProjectileType, IInventory aInventory) {
			if (aInventory != null) for (int i = 0, j = aInventory.getSizeInventory(); i < j; i++) {
				ItemStack rStack = aInventory.getStackInSlot(i);
				if (Stacks.valid(rStack) && rStack.getItem() instanceof IItemProjectile && ((IItemProjectile)rStack.getItem()).hasProjectile(aProjectileType, rStack)) return Stacks.update(rStack);
			}
			return null;
		}
	}
	
	public static class Sounds {
		public static boolean MULTITHREADED = F;
		public static List<PlayedSound> sPlayedSoundMap = new ArrayListNoNulls<PlayedSound>();
		
		public static boolean play(String aSoundName, int aTimeUntilNextSound, float aSoundStrength) {
			if (!CODE_CLIENT) return F;
			return play(aSoundName, aTimeUntilNextSound, aSoundStrength, GT_API.api_proxy.getThePlayer());
		}
		
		public static boolean play(String aSoundName, int aTimeUntilNextSound, float aSoundStrength, Entity aEntity) {
			if (!CODE_CLIENT || aEntity == null) return F;
			return play(aSoundName, aTimeUntilNextSound, aSoundStrength, MathHelper.floor_double(aEntity.posX), MathHelper.floor_double(aEntity.posY), MathHelper.floor_double(aEntity.posZ));
		}
		
		public static boolean play(String aSoundName, int aTimeUntilNextSound, float aSoundStrength, int aX, int aY, int aZ) {
			return play(aSoundName, aTimeUntilNextSound, aSoundStrength, new ChunkCoordinates(aX, aY, aZ));
		}
		
		public static boolean play(String aSoundName, int aTimeUntilNextSound, float aSoundStrength, ChunkCoordinates aCoords) {
			if (!CODE_CLIENT) return F;
			return play(aSoundName, aTimeUntilNextSound, aSoundStrength, 0.9F + RANDOM.nextFloat() * 0.2F, aCoords.posX, aCoords.posY, aCoords.posZ);
		}
		
		public static boolean play(String aSoundName, int aTimeUntilNextSound, float aSoundStrength, float aSoundModulation, int aX, int aY, int aZ) {
			return play(aSoundName, aTimeUntilNextSound, aSoundStrength, aSoundModulation, new ChunkCoordinates(aX, aY, aZ));
		}
		
		public static boolean play(String aSoundName, int aTimeUntilNextSound, float aSoundStrength, float aSoundModulation, ChunkCoordinates aCoords) {
			if (!CODE_CLIENT) return F;
			EntityPlayer aPlayer = GT_API.api_proxy.getThePlayer();
			if (aPlayer == null || !aPlayer.worldObj.isRemote || Code.stringInvalid(aSoundName)) return F;
			if (MULTITHREADED)
				new Thread(new ThreadedSound(aPlayer.worldObj, MathHelper.floor_double(aCoords.posX), MathHelper.floor_double(aCoords.posY), MathHelper.floor_double(aCoords.posZ), aTimeUntilNextSound, aSoundName, aSoundStrength, aSoundModulation), "Sound Effect").start();
			else
				new ThreadedSound(aPlayer.worldObj, MathHelper.floor_double(aCoords.posX), MathHelper.floor_double(aCoords.posY), MathHelper.floor_double(aCoords.posZ), aTimeUntilNextSound, aSoundName, aSoundStrength, aSoundModulation).run();
			return T;
		}
		
		public static boolean send(World aWorld, String aSoundName, float aSoundStrength, float aSoundModulation, int aX, int aY, int aZ) {
			return send(aWorld, aSoundName, aSoundStrength, aSoundModulation, new ChunkCoordinates(aX, aY, aZ));
		}
		
		public static boolean send(World aWorld, String aSoundName, float aSoundStrength, float aSoundModulation, Entity aEntity) {
			return send(aWorld, aSoundName, aSoundStrength, aSoundModulation, MathHelper.floor_double(aEntity.posX), MathHelper.floor_double(aEntity.posY), MathHelper.floor_double(aEntity.posZ));
		}
		
		public static boolean send(World aWorld, String aSoundName, float aSoundStrength, float aSoundModulation, ChunkCoordinates aCoords) {
			if (Code.stringInvalid(aSoundName) || aWorld == null || aWorld.isRemote) return F;
	        NW_API.sendToAllPlayersInRange(new PacketSound(aSoundName, aSoundStrength, aSoundModulation, aCoords), aWorld, aCoords);
			return T;
		}
		
		public static class PlayedSound {
			public final String mSoundName;
			public final int mX, mY, mZ;
			public int mTimer = 0;
			
			public PlayedSound(String aSoundName, double aX, double aY, double aZ, int aTimer) {
				mSoundName = aSoundName==null?"":aSoundName;
				mX = (int)aX;
				mY = (int)aY;
				mZ = (int)aZ;
			}
			
			@Override
			public boolean equals(Object aObject) {
				if (aObject != null && aObject instanceof PlayedSound) {
					return ((PlayedSound)aObject).mX == mX && ((PlayedSound)aObject).mY == mY && ((PlayedSound)aObject).mZ == mZ && ((PlayedSound)aObject).mSoundName.equals(mSoundName);
				}
				return F;
			}
			
			@Override
			public int hashCode() {
				return mX+mY+mZ+mSoundName.hashCode();
			}
		}
		
		public static class ThreadedSound implements Runnable {
			private final int mX, mY, mZ, mTimeUntilNextSound;
			private final World mWorld;
			private final String mSoundName;
			private final float mSoundStrength, mSoundModulation;
			
			public ThreadedSound(World aWorld, int aX, int aY, int aZ, int aTimeUntilNextSound, String aSoundName, float aSoundStrength, float aSoundModulation) {
				mWorld = aWorld; mX = aX; mY = aY; mZ = aZ; mTimeUntilNextSound = aTimeUntilNextSound; mSoundName = aSoundName; mSoundStrength = aSoundStrength; mSoundModulation = aSoundModulation;
			}
			
			@Override
			public void run() {
				try {
					PlayedSound tSound = new PlayedSound(mSoundName, mX, mY, mZ, mTimeUntilNextSound);
					if (Sounds.sPlayedSoundMap.contains(tSound)) return;
					mWorld.playSound(mX+0.5, mY+0.5, mZ+0.5, mSoundName, mSoundStrength, mSoundModulation, T);
					Sounds.sPlayedSoundMap.add(tSound);
				} catch(Throwable e) {/**/}
			}
		}
	}
	
	public static class Entities {
		/** Sends Messages to a Player */
		public static void sendchat(Object aPlayer, String... aChatMessages) {
			if (aPlayer instanceof EntityPlayerMP) for (String aMessage : aChatMessages) ((EntityPlayerMP)aPlayer).addChatComponentMessage(new ChatComponentText(aMessage));
		}
		
		/** Sends Messages to a Player */
		public static void sendchat(Object aPlayer, IChatComponent... aChatMessages) {
			if (aPlayer instanceof EntityPlayerMP) for (IChatComponent aMessage : aChatMessages) ((EntityPlayerMP)aPlayer).addChatComponentMessage(aMessage);
		}
		
		/** Sends Messages to a Player */
		public static void sendchat(Object aPlayer, List aChatMessages, boolean aSkipFirst) {
			if (aChatMessages != null && aPlayer instanceof EntityPlayerMP) for (Object aMessage : aChatMessages) if (aSkipFirst) aSkipFirst=F; else ((EntityPlayerMP)aPlayer).addChatComponentMessage(aMessage instanceof IChatComponent ? (IChatComponent)aMessage : new ChatComponentText(aMessage.toString()));
		}
		
		public static void chat(Object aPlayer, String... aChatMessages) {
			if (aPlayer == null) aPlayer = GT_API.api_proxy.getThePlayer();
			if (aPlayer instanceof EntityPlayer) for (String aMessage : aChatMessages) ((EntityPlayer)aPlayer).addChatComponentMessage(new ChatComponentText(aMessage));
		}
		
		public static void chat(Object aPlayer, IChatComponent... aChatMessages) {
			if (aPlayer == null) aPlayer = GT_API.api_proxy.getThePlayer();
			if (aPlayer instanceof EntityPlayer) for (IChatComponent aMessage : aChatMessages) ((EntityPlayer)aPlayer).addChatComponentMessage(aMessage);
		}
		
		public static void chat(Object aPlayer, List aChatMessages, boolean aSkipFirst) {
			if (aPlayer == null) aPlayer = GT_API.api_proxy.getThePlayer();
			if (aChatMessages != null && aPlayer instanceof EntityPlayer) for (Object aMessage : aChatMessages) if (aSkipFirst) aSkipFirst=F; else ((EntityPlayer)aPlayer).addChatComponentMessage(aMessage instanceof IChatComponent ? (IChatComponent)aMessage : new ChatComponentText(aMessage.toString()));
		}
		
	    public static boolean isWearingFullFrostHazmat(EntityLivingBase aEntity) {
			for (byte i = 1; i < 5; i++) if (!ArmorsGT.HAZMATS_FROST.contains(aEntity.getEquipmentInSlot(i), T)) return F;
			return T;
	    }
	    
	    public static boolean isWearingFullHeatHazmat(EntityLivingBase aEntity) {
			for (byte i = 1; i < 5; i++) if (!ArmorsGT.HAZMATS_HEAT.contains(aEntity.getEquipmentInSlot(i), T)) return F;
			return T;
	    }
	    
	    public static boolean isWearingFullBioHazmat(EntityLivingBase aEntity) {
			for (byte i = 1; i < 5; i++) if (!ArmorsGT.HAZMATS_BIO.contains(aEntity.getEquipmentInSlot(i), T)) return F;
			return T;
	    }
	    
	    public static boolean isWearingFullInsectHazmat(EntityLivingBase aEntity) {
			for (byte i = 1; i < 5; i++) if (!ArmorsGT.HAZMATS_INSECTS.contains(aEntity.getEquipmentInSlot(i), T)) return F;
			return T;
	    }
	    
	    public static boolean isWearingFullRadioHazmat(EntityLivingBase aEntity) {
			for (byte i = 1; i < 5; i++) if (!ArmorsGT.HAZMATS_RADIOACTIVE.contains(aEntity.getEquipmentInSlot(i), T)) return F;
			return T;
	    }
	    
	    public static boolean isWearingFullElectroHazmat(EntityLivingBase aEntity) {
			for (byte i = 1; i < 5; i++) if (!ArmorsGT.HAZMATS_LIGHTNING.contains(aEntity.getEquipmentInSlot(i), T)) return F;
			return T;
	    }
	    
	    public static boolean isWearingFullGasHazmat(EntityLivingBase aEntity) {
			for (byte i = 1; i < 5; i++) if (!ArmorsGT.HAZMATS_GAS.contains(aEntity.getEquipmentInSlot(i), T)) return F;
			return T;
	    }
	    
	    public static float getHeatDamageFromItem(ItemStack aStack) {
	    	OreDictItemData tData = OM.anydata(aStack);
	    	return tData==null?0:(tData.mPrefix==null?0:tData.mPrefix.mHeatDamage) + (tData.hasValidMaterialData()?tData.mMaterial.mMaterial.mHeatDamage:0);
	    }
	    
	    public static int getRadioactivityLevel(ItemStack aStack) {
	    	OreDictItemData tData = OM.anydata(aStack);
	    	long rLevel = 0;
	    	if (tData != null && tData.hasValidMaterialData()) {
	    		for (ObjectStack<Enchantment> tEnchantment : tData.mMaterial.mMaterial.mEnchantmentTools ) if (tEnchantment.mObject instanceof Enchantment_Radioactivity) rLevel = Math.max(rLevel, tEnchantment.mAmount);
	    		for (ObjectStack<Enchantment> tEnchantment : tData.mMaterial.mMaterial.mEnchantmentArmors) if (tEnchantment.mObject instanceof Enchantment_Radioactivity) rLevel = Math.max(rLevel, tEnchantment.mAmount);
	    	}
	    	rLevel = Math.max(rLevel, EnchantmentHelper.getEnchantmentLevel(Enchantment_Radioactivity.INSTANCE.effectId, aStack));
	    	return Code.bindInt(rLevel);
	    }
	    
	    public static boolean isImmuneToBreathingGasses(EntityLivingBase aEntity) {
	    	return isWearingFullGasHazmat(aEntity);
	    }
	    
	    public static boolean applyTemperatureDamage(Entity aEntity, long aTemperature, float aMultiplier) {
			if (aTemperature > 320) return applyHeatDamage (aEntity, (aMultiplier * (aTemperature - 300)) / 50.0F);
			if (aTemperature < 260) return applyFrostDamage(aEntity, (aMultiplier * (270 - aTemperature)) / 25.0F);
	    	return F;
	    }
	    
	    public static boolean applyHeatDamage(Entity aEntity, float aDamage) {
	    	if (aDamage > 0 && aEntity instanceof EntityLivingBase && ((EntityLivingBase)aEntity).isEntityAlive() && aEntity.getClass() != EntityBlaze.class && ((EntityLivingBase)aEntity).getActivePotionEffect(Potion.fireResistance) == null && !isWearingFullHeatHazmat(((EntityLivingBase)aEntity))) {
	        	aEntity.attackEntityFrom(DamageSources.getHeatDamage(), aDamage);
	    		return T;
	    	}
	    	return F;
	    }
	    
	    public static boolean applyFrostDamage(Entity aEntity, float aDamage) {
	    	if (aDamage > 0 && aEntity instanceof EntityLivingBase && ((EntityLivingBase)aEntity).isEntityAlive() && !isWearingFullFrostHazmat(((EntityLivingBase)aEntity))) {
	        	aEntity.attackEntityFrom(DamageSources.getFrostDamage(), aDamage);
	    		return T;
	    	}
	    	return F;
	    }
	    
	    public static boolean applyElectricityDamage(Entity aEntity, long aVoltage, long aAmperage) {
	    	long aDamage = Code.tierMax(aVoltage) * aAmperage * 4;
	    	if (aDamage > 0 && aEntity instanceof EntityLivingBase && ((EntityLivingBase)aEntity).isEntityAlive() && !isWearingFullElectroHazmat(((EntityLivingBase)aEntity))) {
	        	aEntity.attackEntityFrom(DamageSources.getElectricDamage(), aDamage);
	    		return T;
	    	}
	    	return F;
	    }
	    
	    public static boolean applyElectricityDamage(Entity aEntity, long aWattage) {
	    	long aDamage = Code.tierMax(aWattage) * 4;
	    	if (aDamage > 0 && aEntity instanceof EntityLivingBase && ((EntityLivingBase)aEntity).isEntityAlive() && !isWearingFullElectroHazmat(((EntityLivingBase)aEntity))) {
	        	aEntity.attackEntityFrom(DamageSources.getElectricDamage(), aDamage);
	    		return T;
	    	}
	    	return F;
	    }
	    
	    public static boolean applyRadioactivity(Entity aEntity, int aLevel, int aAmountOfItems) {
	    	if (aLevel > 0 && aEntity instanceof EntityLivingBase && ((EntityLivingBase)aEntity).isEntityAlive() && ((EntityLivingBase)aEntity).getCreatureAttribute() != EnumCreatureAttribute.UNDEAD && ((EntityLivingBase)aEntity).getCreatureAttribute() != EnumCreatureAttribute.ARTHROPOD && !isWearingFullRadioHazmat(((EntityLivingBase)aEntity))) {
	        	PotionEffect tEffect = null;
	        	((EntityLivingBase)aEntity).addPotionEffect(new PotionEffect(Potion.moveSlowdown.id	, aLevel * 140 * aAmountOfItems + Math.max(0, ((tEffect = ((EntityLivingBase)aEntity).getActivePotionEffect(Potion.moveSlowdown							))==null?0:tEffect.getDuration())), Math.max(0, (5*aLevel) / 7)));
	        	((EntityLivingBase)aEntity).addPotionEffect(new PotionEffect(Potion.digSlowdown.id	, aLevel * 150 * aAmountOfItems + Math.max(0, ((tEffect = ((EntityLivingBase)aEntity).getActivePotionEffect(Potion.digSlowdown							))==null?0:tEffect.getDuration())), Math.max(0, (5*aLevel) / 7)));
	        	((EntityLivingBase)aEntity).addPotionEffect(new PotionEffect(Potion.confusion.id	, aLevel * 130 * aAmountOfItems + Math.max(0, ((tEffect = ((EntityLivingBase)aEntity).getActivePotionEffect(Potion.confusion							))==null?0:tEffect.getDuration())), Math.max(0, (5*aLevel) / 7)));
	        	((EntityLivingBase)aEntity).addPotionEffect(new PotionEffect(Potion.weakness.id		, aLevel * 150 * aAmountOfItems + Math.max(0, ((tEffect = ((EntityLivingBase)aEntity).getActivePotionEffect(Potion.weakness								))==null?0:tEffect.getDuration())), Math.max(0, (5*aLevel) / 7)));
	        	((EntityLivingBase)aEntity).addPotionEffect(new PotionEffect(Potion.hunger.id		, aLevel * 130 * aAmountOfItems + Math.max(0, ((tEffect = ((EntityLivingBase)aEntity).getActivePotionEffect(Potion.hunger								))==null?0:tEffect.getDuration())), Math.max(0, (5*aLevel) / 7)));
	        	((EntityLivingBase)aEntity).addPotionEffect(new PotionEffect(PotionsGT.ID_RADIATION	, aLevel * 180 * aAmountOfItems + Math.max(0, ((tEffect = ((EntityLivingBase)aEntity).getActivePotionEffect(Potion.potionTypes[PotionsGT.ID_RADIATION]	))==null?0:tEffect.getDuration())), Math.max(0, (5*aLevel) / 7)));
	        	return T;
	    	}
	    	return F;
	    }
	    
		/** checks if a Player is actually a Player and not a FakePlayer or something. */
		public static boolean isPlayer(Object aPlayer) {
			return aPlayer instanceof EntityPlayerMP && !(aPlayer instanceof FakePlayer);
		}
		
		public static boolean isCreative(Object aPlayer) {
			return aPlayer instanceof EntityPlayer && ((EntityPlayer)aPlayer).capabilities.isCreativeMode;
		}
		
		public static boolean isInvincible(Object aPlayer) {
			return aPlayer instanceof EntityPlayer && ((EntityPlayer)aPlayer).capabilities.isCreativeMode;
		}
		
		public static boolean hasInfiniteItems(Object aPlayer) {
			return aPlayer instanceof EntityPlayer && ((EntityPlayer)aPlayer).capabilities.isCreativeMode;
		}
	}
	
	public static class Worlds {
		public static ItemStack suckOneItemStackAt(World aWorld, double aX, double aY, double aZ, double aL, double aH, double aW) {
			for (EntityItem tItem : (ArrayList<EntityItem>)aWorld.getEntitiesWithinAABB(EntityItem.class, AxisAlignedBB.getBoundingBox(aX, aY, aZ, aX+aL, aY+aH, aZ+aW))) {
				if (!tItem.isDead) {
					aWorld.removeEntity(tItem);
					ItemStack rStack = tItem.getEntityItem();
					tItem.setEntityItemStack(Stacks.amount(0, rStack));
					tItem.setDead();
					return rStack;
				}
			}
			return null;
		}
		
		public static boolean isSideObstructed(World aWorld, int aX, int aY, int aZ, byte aSide) {
			aX += OFFSETS_X[aSide]; aY += OFFSETS_Y[aSide]; aZ += OFFSETS_Z[aSide];
			Block tBlock = aWorld.getBlock(aX, aY, aZ);
    		AxisAlignedBB tBoundingBox = tBlock.getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ);
    		if (tBoundingBox == null) return F;
    		switch(aSide) {
    		case 0: return tBoundingBox.maxY-aY > PIXELS_NEG[4] && tBoundingBox.maxX-aX > PIXELS_POS[2] && tBoundingBox.minX-aX < PIXELS_NEG[2] && tBoundingBox.maxZ-aZ > PIXELS_POS[2] && tBoundingBox.minZ-aZ < PIXELS_NEG[2];
    		case 1: return tBoundingBox.minY-aY < PIXELS_POS[4] && tBoundingBox.maxX-aX > PIXELS_POS[2] && tBoundingBox.minX-aX < PIXELS_NEG[2] && tBoundingBox.maxZ-aZ > PIXELS_POS[2] && tBoundingBox.minZ-aZ < PIXELS_NEG[2];
    		case 2: return tBoundingBox.maxZ-aZ > PIXELS_NEG[4] && tBoundingBox.maxX-aX > PIXELS_POS[2] && tBoundingBox.minX-aX < PIXELS_NEG[2] && tBoundingBox.maxY-aY > PIXELS_POS[2] && tBoundingBox.minY-aY < PIXELS_NEG[2];
    		case 3: return tBoundingBox.minZ-aZ < PIXELS_POS[4] && tBoundingBox.maxX-aX > PIXELS_POS[2] && tBoundingBox.minX-aX < PIXELS_NEG[2] && tBoundingBox.maxY-aY > PIXELS_POS[2] && tBoundingBox.minY-aY < PIXELS_NEG[2];
    		case 4: return tBoundingBox.maxX-aX > PIXELS_NEG[4] && tBoundingBox.maxZ-aZ > PIXELS_POS[2] && tBoundingBox.minZ-aZ < PIXELS_NEG[2] && tBoundingBox.maxY-aY > PIXELS_POS[2] && tBoundingBox.minY-aY < PIXELS_NEG[2];
    		case 5: return tBoundingBox.minX-aX < PIXELS_POS[4] && tBoundingBox.maxZ-aZ > PIXELS_POS[2] && tBoundingBox.minZ-aZ < PIXELS_NEG[2] && tBoundingBox.maxY-aY > PIXELS_POS[2] && tBoundingBox.minY-aY < PIXELS_NEG[2];
    		}
    		return F;
		}
		
		/**
		 * This checks if the Dimension is really a Dimension and not another Planet or something.
		 * Used for my Teleporter.
		 */
		public static boolean isRealDimension(int aDimensionID) {
			try {
				if (DimensionManager.getProvider(aDimensionID).getClass().getName().contains("com.xcompwiz.mystcraft")) return T;
			} catch (Throwable e) {/*Do nothing*/}
			try {
				if (DimensionManager.getProvider(aDimensionID).getClass().getName().contains("TwilightForest")) return T;
			} catch (Throwable e) {/*Do nothing*/}
			return aDimensionID == -1 || aDimensionID == 0 || aDimensionID == 1;
		}
		
		public static boolean moveEntityToDimensionAtCoords(Entity aEntity, int aDimension, double aX, double aY, double aZ) {
			WorldServer tTargetWorld = DimensionManager.getWorld(aDimension), tOriginalWorld = DimensionManager.getWorld(aEntity.worldObj.provider.dimensionId);
			if (tTargetWorld != null && tOriginalWorld != null && tTargetWorld != tOriginalWorld) {
				if (aEntity.ridingEntity != null) aEntity.mountEntity(null);
				if (aEntity.riddenByEntity != null) aEntity.riddenByEntity.mountEntity(null);
				
				if (aEntity instanceof EntityPlayerMP) {
					EntityPlayerMP aPlayer = (EntityPlayerMP)aEntity;
			        aPlayer.dimension = aDimension;
			        aPlayer.playerNetServerHandler.sendPacket(new S07PacketRespawn(aPlayer.dimension, aPlayer.worldObj.difficultySetting, aPlayer.worldObj.getWorldInfo().getTerrainType(), aPlayer.theItemInWorldManager.getGameType()));
			        tOriginalWorld.removePlayerEntityDangerously(aPlayer);
			        aPlayer.isDead = F;
			        aPlayer.setWorld(tTargetWorld);
			        MinecraftServer.getServer().getConfigurationManager().func_72375_a(aPlayer, tOriginalWorld);
			        aPlayer.playerNetServerHandler.setPlayerLocation(aX+0.5, aY+0.5, aZ+0.5, aPlayer.rotationYaw, aPlayer.rotationPitch);
			        aPlayer.theItemInWorldManager.setWorld(tTargetWorld);
			        MinecraftServer.getServer().getConfigurationManager().updateTimeAndWeatherForPlayer(aPlayer, tTargetWorld);
			        MinecraftServer.getServer().getConfigurationManager().syncPlayerInventory(aPlayer);
			        Iterator tIterator = aPlayer.getActivePotionEffects().iterator();
			        while (tIterator.hasNext()) {
			            PotionEffect potioneffect = (PotionEffect)tIterator.next();
			            aPlayer.playerNetServerHandler.sendPacket(new S1DPacketEntityEffect(aPlayer.getEntityId(), potioneffect));
			        }
			        aPlayer.playerNetServerHandler.setPlayerLocation(aX+0.5, aY+0.5, aZ+0.5, aPlayer.rotationYaw, aPlayer.rotationPitch);
			        FMLCommonHandler.instance().firePlayerChangedDimensionEvent(aPlayer, tOriginalWorld.provider.dimensionId, aDimension);
				} else {
					aEntity.setPosition(aX+0.5, aY+0.5, aZ+0.5);
					aEntity.worldObj.removeEntity(aEntity);
					aEntity.dimension = aDimension;
					aEntity.isDead = F;
		            Entity tNewEntity = EntityList.createEntityByName(EntityList.getEntityString(aEntity), tTargetWorld);
		            if (tNewEntity != null) {
		            	tNewEntity.copyDataFrom(aEntity, T);
			            aEntity.setDead();
		            	tNewEntity.isDead = F;
		            	boolean temp = tNewEntity.forceSpawn;
			            tNewEntity.forceSpawn = T;
		            	tTargetWorld.spawnEntityInWorld(tNewEntity);
			            tNewEntity.forceSpawn = temp;
		            	tNewEntity.isDead = F;
		            	aEntity = tNewEntity;
		            }
				}
				
				if (aEntity instanceof EntityLivingBase) {
					((EntityLivingBase)aEntity).setPositionAndUpdate(aX, aY, aZ);
				} else {
					aEntity.setPosition(aX, aY, aZ);
				}
				
	            tOriginalWorld.resetUpdateEntityTick();
	            tTargetWorld.resetUpdateEntityTick();
				return T;
			}
			return F;
		}
		
		/** to get a TileEntity properly, according to my additional Interfaces. Normally you should set aIgnoreUnloadedChunks to false, unless you have already checked these Coordinates, or you want to load Chunks */
	    public static DelegatorTileEntity<TileEntity> getTileEntity(World aWorld, ChunkCoordinates aCoords, byte aSide, boolean aIgnoreUnloadedChunks) {
	    	TileEntity aTileEntity = getTileEntity(aWorld, aCoords, aIgnoreUnloadedChunks);
			return aTileEntity instanceof ITileEntityDelegating ? ((ITileEntityDelegating)aTileEntity).getDelegateTileEntity(aSide) : new DelegatorTileEntity<TileEntity>(aTileEntity, aWorld, aCoords, aSide);
	    }
	    
		/** to get a TileEntity properly, according to my additional Interfaces. Normally you should set aIgnoreUnloadedChunks to false, unless you have already checked these Coordinates, or you want to load Chunks */
	    public static DelegatorTileEntity<TileEntity> getTileEntity(World aWorld, int aX, int aY, int aZ, byte aSide, boolean aIgnoreUnloadedChunks) {
	    	TileEntity aTileEntity = getTileEntity(aWorld, aX, aY, aZ, aIgnoreUnloadedChunks);
			return aTileEntity instanceof ITileEntityDelegating ? ((ITileEntityDelegating)aTileEntity).getDelegateTileEntity(aSide) : new DelegatorTileEntity<TileEntity>(aTileEntity, aWorld, aX, aY, aZ, aSide);
	    }
	    
		/** to get a TileEntity properly, according to my additional Interfaces. Normally you should set aIgnoreUnloadedChunks to false, unless you have already checked these Coordinates, or you want to load Chunks */
	    public static TileEntity getTileEntity(World aWorld, ChunkCoordinates aCoords, boolean aIgnoreUnloadedChunks) {
	    	if (aIgnoreUnloadedChunks || aWorld.blockExists(aCoords.posX, aCoords.posY, aCoords.posZ)) {
	        	TileEntity rTileEntity = aWorld.getTileEntity(aCoords.posX, aCoords.posY, aCoords.posZ);
	        	if (rTileEntity != null) return rTileEntity;
	        	Block tBlock = aWorld.getBlock(aCoords.posX, aCoords.posY, aCoords.posZ);
	        	return tBlock instanceof IBlockTileEntity ? ((IBlockTileEntity)tBlock).getTileEntity(aWorld, aCoords.posX, aCoords.posY, aCoords.posZ) : null;
	    	}
			return null;
	    }
	    
		/** to get a TileEntity properly, according to my additional Interfaces. Normally you should set aIgnoreUnloadedChunks to false, unless you have already checked these Coordinates, or you want to load Chunks */
	    public static TileEntity getTileEntity(World aWorld, int aX, int aY, int aZ, boolean aIgnoreUnloadedChunks) {
	    	if (aIgnoreUnloadedChunks || aWorld.blockExists(aX, aY, aZ)) {
	        	TileEntity rTileEntity = aWorld.getTileEntity(aX, aY, aZ);
	        	if (rTileEntity != null) return rTileEntity;
	        	Block tBlock = aWorld.getBlock(aX, aY, aZ);
	        	return tBlock instanceof IBlockTileEntity ? ((IBlockTileEntity)tBlock).getTileEntity(aWorld, aX, aY, aZ) : null;
	    	}
			return null;
	    }
	    
		/** Sets the TileEntity at the passed position, with the option of turning adjacent TileEntity updates off. */
	    public static TileEntity setTileEntity(World aWorld, int aX, int aY, int aZ, TileEntity aTileEntity, boolean aCauseTileEntityUpdates) {
	    	if (aCauseTileEntityUpdates) aWorld.setTileEntity(aX, aY, aZ, aTileEntity); else {
		        Chunk tChunk = aWorld.getChunkFromChunkCoords(aX >> 4, aZ >> 4);
		        if (tChunk != null) {
		    		aWorld.addTileEntity(aTileEntity);
		        	tChunk.func_150812_a(aX & 15, aY, aZ & 15, aTileEntity);
		        	tChunk.isModified = T;
		        }
			}
	    	return aTileEntity;
	    }
	    
		/** @return the regular Temperature of the World at this Location according to my calculations. In Kelvin, ofcourse. */
		public static long getEnvironmentalTemperature(World aWorld, int aX, int aY, int aZ) {
			BiomeGenBase tBiome = aWorld.getBiomeGenForCoords(aX, aZ);
			return Math.max(1, tBiome == null ? DEFAULT_ENVIRONMENT_TEMPERATURE : (long)(C - 3 + tBiome.getFloatTemperature(aX, aY, aZ) * 20));
		}
		
		/** @return the regular Temperature of the World at this Location according to my calculations. In Kelvin, ofcourse. */
		public static long getTemperature(World aWorld, int aX, int aY, int aZ) {
			long rTemperature = getEnvironmentalTemperature(aWorld, aX, aY, aZ);
			if (getCoordsOnFire(aWorld, aX, aY, aZ)) rTemperature = Math.max(rTemperature, C + 200);
			for (ChunkCoordinates tCoords : new ChunkCoordinates[] {new ChunkCoordinates(aX, aY, aZ), new ChunkCoordinates(aX+1, aY, aZ), new ChunkCoordinates(aX-1, aY, aZ), new ChunkCoordinates(aX, aY+1, aZ), new ChunkCoordinates(aX, aY-1, aZ), new ChunkCoordinates(aX, aY, aZ+1), new ChunkCoordinates(aX, aY, aZ-1)}) {
				Block tBlock = getBlock(aWorld, tCoords.posX, tCoords.posY, tCoords.posZ, F);
				if (tBlock == Blocks.lava || tBlock == Blocks.flowing_lava) rTemperature = Math.max(rTemperature, C + 500);
				else if (tBlock instanceof BlockFire) rTemperature = Math.max(rTemperature, C + 200);
			}
			return rTemperature;
		}
		
		public static ItemStack getStack(World aWorld, int aX, int aY, int aZ) {
			Block tBlock = aWorld.getBlock(aX, aY, aZ);
			return Stacks.make(tBlock, 1, tBlock instanceof IBlockExtendedMetaData ? ((IBlockExtendedMetaData)tBlock).getExtendedMetaData(aWorld, aX, aY, aZ) : aWorld.getBlockMetadata(aX, aY, aZ));
		}
		
		public static Block getBlock(World aWorld, int aX, int aY, int aZ, boolean aIgnoreUnloadedChunks) {
			if (aIgnoreUnloadedChunks || aWorld.blockExists(aX, aY, aZ)) return aWorld.getBlock(aX, aY, aZ);
			return NB;
		}
		
		public static boolean crossedChunkBorder(int aFromX, int aFromZ, int aToX, int aToZ) {
			return aFromX >> 4 != aToX >> 4 || aFromZ >> 4 != aToZ >> 4;
		}
		
		public static boolean areCoordsEven(TileEntity aTileEntity) {
			return areCoordsEven(aTileEntity.xCoord, aTileEntity.yCoord, aTileEntity.zCoord);
		}
		
		public static boolean areCoordsEven(ChunkCoordinates aCoords) {
			return areCoordsEven(aCoords.posX, aCoords.posY, aCoords.posZ);
		}
		
		public static boolean areCoordsEven(int... aCoords) {
			int i = 0; for (int tCoord : aCoords) if (tCoord % 2 == 0) i++; return i % 2 == 0;
		}
		
		public static boolean setBlock(World aWorld, int aX, int aY, int aZ, ItemStack aStack) {
			Block tBlock = Stacks.block(aStack);
			if (tBlock == NB) return F;
			if (tBlock instanceof IBlockPlacable) return ((IBlockPlacable)tBlock).placeBlock(aWorld, aX, aY, aZ, (byte)6, Stacks.meta(aStack), aStack.getTagCompound(), T, F);
			if (Stacks.meta(aStack) < 16) return aWorld.setBlock(aX, aY, aZ, tBlock, Stacks.meta(aStack), 3);
			return F;
		}
		
		public static boolean isRegularStoneBlock(Block aBlock, short aMetaData) {
			ItemStackContainer tStack = new ItemStackContainer(aBlock, 1, aMetaData);
			if (BlocksGT.stoneToBrokenOres.containsKey(tStack) || BlocksGT.stoneToNormalOres.containsKey(tStack) || BlocksGT.stoneToSmallOres.containsKey(tStack)) return T;
			if (aBlock == Blocks.obsidian) return T;
			return F;
		}
		
		public static boolean isOreBlock(Block aBlock, short aMetaData) {
			if (aBlock instanceof IBlockPlacable && (BlocksGT.stoneToBrokenOres.containsValue(aBlock) || BlocksGT.stoneToNormalOres.containsValue(aBlock) || BlocksGT.stoneToSmallOres.containsValue(aBlock))) return T;
			if (OM.prefixcontains(Stacks.make(aBlock, 1, aMetaData), TD.Prefix.ORE)) return T;
			return F;
		}
		
		public static boolean isOreOrRegularStoneBlock(Block aBlock, short aMetaData) {
			return isOreBlock(aBlock, aMetaData) || isRegularStoneBlock(aBlock, aMetaData);
		}
		
		public static boolean isVisuallyOccluded(World aWorld, int aX, int aY, int aZ, boolean aIgnoreUnloadedChunks, boolean aDefault) {
			return isVisuallyOpaque(aWorld, aX+1, aY, aZ, aIgnoreUnloadedChunks, aDefault) && isVisuallyOpaque(aWorld, aX-1, aY, aZ, aIgnoreUnloadedChunks, aDefault) && isVisuallyOpaque(aWorld, aX, aY+1, aZ, T, aDefault) && isVisuallyOpaque(aWorld, aX, aY-1, aZ, T, aDefault) && isVisuallyOpaque(aWorld, aX, aY, aZ+1, aIgnoreUnloadedChunks, aDefault) && isVisuallyOpaque(aWorld, aX, aY, aZ-1, aIgnoreUnloadedChunks, aDefault);
		}
		
		public static boolean isVisuallyOpaque(World aWorld, int aX, int aY, int aZ, boolean aIgnoreUnloadedChunks, boolean aDefault) {
			return aIgnoreUnloadedChunks || aWorld.blockExists(aX, aY, aZ) ? isVisuallyOpaque(aWorld.getBlock(aX, aY, aZ)) : aDefault;
		}
		
		public static boolean isVisuallyOpaque(Block aBlock) {
			return aBlock.isOpaqueCube() || VISUALLY_OPAQUE_BLOCKS.contains(aBlock);
		}
		
		public static boolean isOccluded(World aWorld, int aX, int aY, int aZ, boolean aIgnoreUnloadedChunks, boolean aDefault) {
			return isOpaque(aWorld, aX+1, aY, aZ, aIgnoreUnloadedChunks, aDefault) && isOpaque(aWorld, aX-1, aY, aZ, aIgnoreUnloadedChunks, aDefault) && isOpaque(aWorld, aX, aY+1, aZ, T, aDefault) && isOpaque(aWorld, aX, aY-1, aZ, T, aDefault) && isOpaque(aWorld, aX, aY, aZ+1, aIgnoreUnloadedChunks, aDefault) && isOpaque(aWorld, aX, aY, aZ-1, aIgnoreUnloadedChunks, aDefault);
		}
		
		public static boolean isOpaque(World aWorld, int aX, int aY, int aZ, boolean aIgnoreUnloadedChunks, boolean aDefault) {
			if (aIgnoreUnloadedChunks || aWorld.blockExists(aX, aY, aZ)) return aWorld.getBlock(aX, aY, aZ).isOpaqueCube();
			return aDefault;
		}
		
		public static boolean isAir(World aWorld, int aX, int aY, int aZ) {
			return aWorld.getBlock(aX, aY, aZ).isAir(aWorld, aX, aY, aZ);
		}
		
		public static boolean hasBlockHitBox(World aWorld, int aX, int aY, int aZ) {
			return aWorld.getBlock(aX, aY, aZ).getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ) != null;
		}
		
		
		public static void setOnFire(World aWorld, int aX, int aY, int aZ, boolean aReplaceCenter, boolean aCheckFlammability) {
			setToFire(aWorld, aX+1, aY  , aZ  , aCheckFlammability);
			setToFire(aWorld, aX-1, aY  , aZ  , aCheckFlammability);
			setToFire(aWorld, aX  , aY+1, aZ  , aCheckFlammability);
			setToFire(aWorld, aX  , aY-1, aZ  , aCheckFlammability);
			setToFire(aWorld, aX  , aY  , aZ+1, aCheckFlammability);
			setToFire(aWorld, aX  , aY  , aZ-1, aCheckFlammability);
			if (aReplaceCenter)
			setToFire(aWorld, aX  , aY  , aZ  , aCheckFlammability);
		}
		
		public static void setOnFire(World aWorld, ChunkCoordinates aCoords, boolean aReplaceCenter, boolean aCheckFlammability) {
			setToFire(aWorld, aCoords.posX+1, aCoords.posY  , aCoords.posZ  , aCheckFlammability);
			setToFire(aWorld, aCoords.posX-1, aCoords.posY  , aCoords.posZ  , aCheckFlammability);
			setToFire(aWorld, aCoords.posX  , aCoords.posY+1, aCoords.posZ  , aCheckFlammability);
			setToFire(aWorld, aCoords.posX  , aCoords.posY-1, aCoords.posZ  , aCheckFlammability);
			setToFire(aWorld, aCoords.posX  , aCoords.posY  , aCoords.posZ+1, aCheckFlammability);
			setToFire(aWorld, aCoords.posX  , aCoords.posY  , aCoords.posZ-1, aCheckFlammability);
			if (aReplaceCenter)
			setToFire(aWorld, aCoords, aCheckFlammability);
		}
		
		public static boolean setToFire(World aWorld, int aX, int aY, int aZ, boolean aCheckFlammability) {
			Block tBlock = aWorld.getBlock(aX, aY, aZ);
			if (tBlock.getMaterial() == Material.carpet || tBlock.getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ) == null) {
				if (tBlock.getFlammability(aWorld, aX, aY, aZ, FORGE_DIR[SIDE_ANY]) > 0) return aWorld.setBlock(aX, aY, aZ, Blocks.fire, 0, 3);
				if (aCheckFlammability) {
					for (byte tSide : ALL_SIDES_VALID) if (aWorld.getBlock(aX+OFFSETS_X[tSide], aY+OFFSETS_Y[tSide], aZ+OFFSETS_Z[tSide]).getFlammability(aWorld, aX+OFFSETS_X[tSide], aY+OFFSETS_Y[tSide], aZ+OFFSETS_Z[tSide], FORGE_DIR_OPPOSITES[tSide]) > 0) return aWorld.setBlock(aX, aY, aZ, Blocks.fire);
				} else {
					return aWorld.setBlock(aX, aY, aZ, Blocks.fire, 0, 3);
				}
			}
			return F;
		}
		
		public static boolean setToFire(World aWorld, ChunkCoordinates aCoords, boolean aCheckFlammability) {
			Block tBlock = aWorld.getBlock(aCoords.posX, aCoords.posY, aCoords.posZ);
			if (tBlock.getMaterial() == Material.carpet || tBlock.getCollisionBoundingBoxFromPool(aWorld, aCoords.posX, aCoords.posY, aCoords.posZ) == null) {
				if (tBlock.getFlammability(aWorld, aCoords.posX, aCoords.posY, aCoords.posZ, FORGE_DIR[SIDE_ANY]) > 0) return aWorld.setBlock(aCoords.posX, aCoords.posY, aCoords.posZ, Blocks.fire, 0, 3);
				if (aCheckFlammability) {
					for (byte tSide : ALL_SIDES_VALID) if (aWorld.getBlock(aCoords.posX+OFFSETS_X[tSide], aCoords.posY+OFFSETS_Y[tSide], aCoords.posZ+OFFSETS_Z[tSide]).getFlammability(aWorld, aCoords.posX+OFFSETS_X[tSide], aCoords.posY+OFFSETS_Y[tSide], aCoords.posZ+OFFSETS_Z[tSide], FORGE_DIR_OPPOSITES[tSide]) > 0) return aWorld.setBlock(aCoords.posX, aCoords.posY, aCoords.posZ, Blocks.fire);
				} else {
					return aWorld.setBlock(aCoords.posX, aCoords.posY, aCoords.posZ, Blocks.fire, 0, 3);
				}
			}
			return F;
		}
		
		public static boolean getCoordsOnFire(World aWorld, int aX, int aY, int aZ) {
			return getBlock(aWorld, aX, aY, aZ, F) instanceof BlockFire || getBlock(aWorld, aX+1, aY, aZ, F) instanceof BlockFire || getBlock(aWorld, aX-1, aY, aZ, F) instanceof BlockFire || getBlock(aWorld, aX, aY+1, aZ, F) instanceof BlockFire || getBlock(aWorld, aX, aY-1, aZ, F) instanceof BlockFire || getBlock(aWorld, aX, aY, aZ+1, F) instanceof BlockFire || getBlock(aWorld, aX, aY, aZ-1, F) instanceof BlockFire;
		}
		
		public static int getCoordinateScan(ArrayList<String> aList, EntityPlayer aPlayer, World aWorld, int aScanLevel, int aX, int aY, int aZ, int aSide, float aClickX, float aClickY, float aClickZ) {
			if (aList == null) return 0;
			
			ArrayList<String> tList = new ArrayListNoNulls<String>();
			int rEUAmount = 0;
			
			TileEntity tTileEntity = getTileEntity(aWorld, aX, aY, aZ, T);
		    
		    Block tBlock = aWorld.getBlock(aX, aY, aZ);
		    
		    tList.add("----- X: " + aX + " Y: " + aY + " Z: " + aZ + " -----");
		    try {
			    if (tTileEntity != null && tTileEntity instanceof IInventory)
			    	tList.add("Name: " + ((IInventory)tTileEntity).getInventoryName() + "  MetaData: " + aWorld.getBlockMetadata(aX, aY, aZ));
			    else
			    	tList.add("Name: " + tBlock.getUnlocalizedName() + "  MetaData: " + aWorld.getBlockMetadata(aX, aY, aZ));
			    
			    tList.add("Hardness: " + tBlock.getBlockHardness(aWorld, aX, aY, aZ) + "  Blast Resistance: " + tBlock.getExplosionResistance(aPlayer, aWorld, aX, aY, aZ, aPlayer.posX, aPlayer.posY, aPlayer.posZ));
			    if (tBlock.isBeaconBase(aWorld, aX, aY, aZ, aX, aY+1, aZ)) tList.add("Is valid Beacon Pyramid Material");
			} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
		    if (tTileEntity != null) {
				try {if (tTileEntity instanceof IFluidHandler) {
					rEUAmount+=500;
				    FluidTankInfo[] tTanks = ((IFluidHandler)tTileEntity).getTankInfo(FORGE_DIR[aSide]);
				    if (tTanks != null) for (byte i = 0; i < tTanks.length; i++) {
				    	tList.add("Tank " + i + ": " + (tTanks[i].fluid==null?0:tTanks[i].fluid.amount) + " / " + tTanks[i].capacity + " " + Fluids.name(tTanks[i].fluid, T));
				    }
				}} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.reactor.IReactorChamber) {
					rEUAmount+=500;
				    tTileEntity = (TileEntity)(((ic2.api.reactor.IReactorChamber)tTileEntity).getReactor());
				}} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.reactor.IReactor) {
					rEUAmount+=500;
					tList.add("Heat: " + ((ic2.api.reactor.IReactor)tTileEntity).getHeat() + "/" + ((ic2.api.reactor.IReactor)tTileEntity).getMaxHeat()
							+ "  HEM: " + ((ic2.api.reactor.IReactor)tTileEntity).getHeatEffectModifier() + "  Base EU Output: "/* + ((ic2.api.reactor.IReactor)tTileEntity).getOutput()*/);
				}} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.tile.IWrenchable) {
					rEUAmount+=100;
			        tList.add("Facing: " + ((ic2.api.tile.IWrenchable)tTileEntity).getFacing() + " / Chance: " + (((ic2.api.tile.IWrenchable)tTileEntity).getWrenchDropRate()*100) + "%");
				    tList.add(((ic2.api.tile.IWrenchable)tTileEntity).wrenchCanRemove(aPlayer)?"You can remove this with a Wrench":"You can NOT remove this with a Wrench");
				}} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.energy.tile.IEnergyTile) {
					rEUAmount+=200;
				    //aList.add(((ic2.api.energy.tile.IEnergyTile)tTileEntity).isAddedToEnergyNet()?"Added to E-net":"Not added to E-net! Bug?");
				}} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.energy.tile.IEnergySink) {
					rEUAmount+=400;
			        //aList.add("Demanded Energy: " + ((ic2.api.energy.tile.IEnergySink)tTileEntity).demandsEnergy());
			        //tList.add("Max Safe Input: " + getTier(((ic2.api.energy.tile.IEnergySink)tTileEntity).getSinkTier()));
			        //tList.add("Max Safe Input: " + ((ic2.api.energy.tile.IEnergySink)tTileEntity).getMaxSafeInput());
			    }} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.energy.tile.IEnergySource) {
					rEUAmount+=400;
			        //aList.add("Max Energy Output: " + ((ic2.api.energy.tile.IEnergySource)tTileEntity).getMaxEnergyOutput());
			    }} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.energy.tile.IEnergyConductor) {
					rEUAmount+=200;
			        tList.add("Conduction Loss: " + ((ic2.api.energy.tile.IEnergyConductor)tTileEntity).getConductionLoss());
			    }} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.tile.IEnergyStorage) {
					rEUAmount+=200;
			        tList.add("Contained Energy: " + ((ic2.api.tile.IEnergyStorage)tTileEntity).getStored() + " of " + ((ic2.api.tile.IEnergyStorage)tTileEntity).getCapacity());
			        //aList.add(((ic2.api.tile.IEnergyStorage)tTileEntity).isTeleporterCompatible(ic2.api.Direction.YP)?"Teleporter Compatible":"Not Teleporter Compatible");
				}} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
				try {if (tTileEntity instanceof ic2.api.crops.ICropTile) {
					if (((ic2.api.crops.ICropTile)tTileEntity).getScanLevel() < 4) {
						rEUAmount+=10000;
						((ic2.api.crops.ICropTile)tTileEntity).setScanLevel((byte)4);
					}
					rEUAmount+=1000;
					tList.add("Type -- Crop-Name: " + LanguageHandler.translate(((ic2.api.crops.ICropTile)tTileEntity).getCrop().name())
				    		+ "  Growth: " + ((ic2.api.crops.ICropTile)tTileEntity).getGrowth()
				    		+ "  Gain: " + ((ic2.api.crops.ICropTile)tTileEntity).getGain()
				    		+ "  Resistance: " + ((ic2.api.crops.ICropTile)tTileEntity).getResistance()
				    		);
				    tList.add("Plant -- Fertilizer: " + ((ic2.api.crops.ICropTile)tTileEntity).getNutrientStorage()
				    		+ "  Water: " + ((ic2.api.crops.ICropTile)tTileEntity).getHydrationStorage()
				    		+ "  Weed-Ex: " + ((ic2.api.crops.ICropTile)tTileEntity).getWeedExStorage()
				    		+ "  Scan-Level: " + ((ic2.api.crops.ICropTile)tTileEntity).getScanLevel()
				    		);
				    tList.add("Environment -- Nutrients: " + ((ic2.api.crops.ICropTile)tTileEntity).getNutrients()
				    		+ "  Humidity: " + ((ic2.api.crops.ICropTile)tTileEntity).getHumidity()
				    		+ "  Air-Quality: " + ((ic2.api.crops.ICropTile)tTileEntity).getAirQuality()
				    		);
				    String tString = "";
				    for (String tAttribute : ((ic2.api.crops.ICropTile)tTileEntity).getCrop().attributes()) {
				    	tString += ", " + tAttribute;
				    }
				    tList.add("Attributes:" + tString.replaceFirst(",", ""));
				    tList.add("Discovered by: " + ((ic2.api.crops.ICropTile)tTileEntity).getCrop().discoveredBy());
					
				}} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	    	}
		    try {if (tBlock instanceof IBlockDebugable) {
		    	rEUAmount+=500;
		        ArrayList<String> temp = ((IBlockDebugable)tBlock).getDebugInfo(aPlayer, aX, aY, aZ, 3);
		        if (temp != null) tList.addAll(temp);
		    }} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
		    
		    BlockScanningEvent tEvent = new BlockScanningEvent(aWorld, aPlayer, aX, aY, aZ, (byte)aSide, aScanLevel, tBlock, tTileEntity, tList, aClickX, aClickY, aClickZ);
		    tEvent.mEUCost = rEUAmount;
		    MinecraftForge.EVENT_BUS.post(tEvent);
		    if (!tEvent.isCanceled()) aList.addAll(tList);
			return tEvent.mEUCost;
		}
	}
	
	public static synchronized boolean removeSimpleIC2MachineRecipe(ItemStack aInput, Map<IRecipeInput, RecipeOutput> aRecipeList, ItemStack aOutput) {
		if ((Stacks.invalid(aInput) && Stacks.invalid(aOutput)) || aRecipeList == null) return F;
		boolean rReturn = F;
		Iterator<Map.Entry<IRecipeInput, RecipeOutput>> tIterator = aRecipeList.entrySet().iterator();
		aOutput = OM.get_(aOutput);
		while (tIterator.hasNext()) {
			Map.Entry<IRecipeInput, RecipeOutput> tEntry = tIterator.next();
			if (aInput == null || tEntry.getKey().matches(aInput)) {
				List<ItemStack> tList = tEntry.getValue().items;
				if (tList != null) for (ItemStack tOutput : tList) if (Stacks.invalid(aOutput) || Stacks.equal(OM.get(tOutput), aOutput)) {
					tIterator.remove();
					rReturn = T;
					break;
				}
			}
		}
		return rReturn;
	}
	
	public static boolean addSimpleIC2MachineRecipe(IMachineRecipeManager aRecipeManager, ItemStack aInput, NBTTagCompound aNBT, Object... aOutput) {
		if (Stacks.invalid(aInput) || aOutput == null || aRecipeManager == null) return F;
		aOutput = Code.getWithoutNulls(aOutput).toArray(ZL_OBJECT);
		if (aOutput.length == 0) return F;
		OreDictItemData tOreName = OM.association_(aInput);
		if (aRecipeManager instanceof IMachineRecipeManagerExt) {
			if (tOreName != null) {
				((IMachineRecipeManagerExt)aRecipeManager).addRecipe(new RecipeInputOreDict(tOreName.toString(), aInput.stackSize), aNBT, T, OreDictManager.INSTANCE.getStackArray(T, aOutput));
			} else {
				((IMachineRecipeManagerExt)aRecipeManager).addRecipe(new RecipeInputItemStack(Stacks.copy(aInput), aInput.stackSize), aNBT, T, OreDictManager.INSTANCE.getStackArray(T, aOutput));
			}
		} else {try {
			if (tOreName != null) {
				aRecipeManager.addRecipe(new RecipeInputOreDict(tOreName.toString(), aInput.stackSize), aNBT, OreDictManager.INSTANCE.getStackArray(T, aOutput));
			} else {
				aRecipeManager.addRecipe(new RecipeInputItemStack(Stacks.copy(aInput), aInput.stackSize), aNBT, OreDictManager.INSTANCE.getStackArray(T, aOutput));
			}
		} catch(Throwable e) {/**/}}
		return T;
	}
	
	public static boolean addSimpleIC2MachineRecipe(ItemStack aInput, Map<IRecipeInput, RecipeOutput> aRecipeList, NBTTagCompound aNBT, Object... aOutput) {
		if (Stacks.invalid(aInput) || aOutput.length == 0 || aRecipeList == null) return F;
		OreDictItemData tOreName = OM.association_(aInput);
		if (tOreName != null) {
			aRecipeList.put(new RecipeInputOreDict(tOreName.toString(), aInput.stackSize), new RecipeOutput(aNBT, OreDictManager.INSTANCE.getStackArray(T, aOutput)));
		} else {
			aRecipeList.put(new RecipeInputItemStack(Stacks.copy(aInput), aInput.stackSize), new RecipeOutput(aNBT, OreDictManager.INSTANCE.getStackArray(T, aOutput)));
		}
		return T;
	}
	
	/**
	 * Yes, I have read all those warning that it might break. But I don't expect any further development on this Function by Forge during 1.7.10.
	 * 
	 * That said, I've put a try/catch around this Stuff in case of random Errors.
	 */
	public static class LoadingBar {
		public static boolean mEnabled = T;
		public static Object mBar = null;
		public static int mSize = 0, mCount = 0;
		
		@SuppressWarnings("deprecation")
		public static boolean start(String aName, int aSize) {
			if (mBar == null && mEnabled) {
				try {
					mBar = cpw.mods.fml.common.ProgressManager.push(aName, aSize);
					mSize = aSize;
					mCount = 0;
					return T;
				} catch(NoClassDefFoundError e) {
					mEnabled = F;
				} catch(Throwable e) {/**/}
			}
			return F;
		}
		
		@SuppressWarnings("deprecation")
		public static boolean step(Object aStep) {
			if (mBar != null && mEnabled) {
				if (mCount++ < mSize) {
					try {
						String tStepName = (aStep == null ? "null" : aStep.toString());
						((cpw.mods.fml.common.ProgressManager.ProgressBar)mBar).step(tStepName);
						return T;
					} catch(NoClassDefFoundError e) {
						mEnabled = F;
					} catch(Throwable e) {/**/}
					return F;
				}
				ERR.println("WARNING: Progress Bar needed forced Finish, because of too many Steps.");
				finish();
				return F;
			}
			return F;
		}
		
		@SuppressWarnings("deprecation")
		public static boolean finish() {
			if (mBar != null && mEnabled) {
				if (mCount != mSize) ERR.println("WARNING: Progress Bar needed forced Finish, because of too few Steps.");
				try {
					cpw.mods.fml.common.ProgressManager.pop((cpw.mods.fml.common.ProgressManager.ProgressBar)mBar);
					mBar = null;
					mSize = 0;
					mCount = 0;
					return T;
				} catch(NoClassDefFoundError e) {
					mEnabled = F;
				} catch(Throwable e) {/**/}
				mBar = null;
				mSize = 0;
				mCount = 0;
				return F;
			}
			return F;
		}
	}
}